local nk = Nick

--Ghost Effect
function nk.GhostShape(mo, color)
	if mo and mo.valid
		if (leveltime & 1)
			local ghs = P_SpawnGhostMobj(mo)
			if ghs and ghs.valid
				ghs.color = color
				ghs.blendmode = AST_ADD
				ghs.colorized = true
				ghs.frame = FF_FULLBRIGHT|$
			end
		end
	end
end

--Thanks luigi budd for this function
--can @p1 damage @p2?
--P_TagDamage, P_PlayerHitsPlayer
--takis func
--no reason to rename this one lol (there is now)
rawset(_G, "Nick_CanHurtPlayer", function(p1,p2,nobs)
	if not (p1 and p1.valid)
	or not (p2 and p2.valid)
		return false
	end
	
	local allowhurt = true
	local ff = CV_FindVar("friendlyfire").value
	
	if not (nobs)
		--no griefing!
		if (TAKIS_NET
		and TAKIS_NET.inspecialstage)
		or G_IsSpecialStage(gamemap)
			return false
		end
		
		if not (p1.mo and p1.mo.valid)
			return false
		end
		if not (p2.mo and p2.mo.valid)
			return false
		end
		
		if not p1.mo.health
			return false
		end
		if not p2.mo.health
			return false
		end
		
		--non-supers can hit each other, supers can hit other supers,
		--but non-supers cant hit supers
		local superallowed = true
		if (p1.powers[pw_super])
			superallowed = true
		elseif (p2.powers[pw_super])
			superallowed = false
		end
		
		if ((p2.powers[pw_flashing])
		or (p2.powers[pw_invulnerability])
		or not superallowed)
			return false
		end
		
		if (leveltime <= CV_FindVar("hidetime").value*TICRATE)
		and (gametyperules & GTR_STARTCOUNTDOWN)
			return false
		end
		
		if (p1.botleader == p2)
			return false
		end
		
		--battlemod parrying
		/*
		if (p2.guard and p2.guard == 1)
			return false
		end
		
		if p1.takistable
		and p1.takistable.inBattle
		and CBW_Battle.MyTeam(p1,p2)
			return false
		end
		
		if p1.takistable
		and p1.takistable.inSaxaMM
		and (p1.mm and p1.mm.role ~= MMROLE_MURDERER)
			return false
		end
		*/
	end
	
	-- In COOP/RACE, you can't hurt other players unless cv_friendlyfire is on
	if (not (ff or (gametyperules & GTR_FRIENDLYFIRE))
	and (gametyperules & (GTR_FRIENDLY|GTR_RACE)))
		allowhurt = false
	end
	
	if G_TagGametype()
		if ((p2.pflags & PF_TAGIT and not ((ff or (gametyperules & GTR_FRIENDLYFIRE))
		and p1.pflags & PF_TAGIT)))
			allowhurt = false
		end
		
		if (not (ff or (gametyperules & GTR_FRIENDLYFIRE))
		and (p2.pflags & PF_TAGIT == p1.pflags & PF_TAGIT))
			allowhurt = false
		end
	end
	
	if G_GametypeHasTeams()
		if (not (ff or gametyperules & GTR_FRIENDLYFIRE))
		and (p2.ctfteam == p1.ctfteam)
			allowhurt = false
		end
	end
	
	if P_PlayerInPain(p1)
		allowhurt = false
	end
	
	if Takis_Hook
		/*
			if true, force a hit
			if false, force no hits
			if nil, use the above checks
		*/
		local hook_event = Takis_Hook.events["CanPlayerHurtPlayer"]
		for i,v in ipairs(hook_event)
			local result = Takis_Hook.tryRunHook("CanPlayerHurtPlayer", v, p1,p2,nobs)
			if result ~= nil
				allowhurt = result
			end
		end
	end
	
	return allowhurt
end)

nk.HomingKick = function(me,target,speed)
	local p = me.player
	if not (target and target.valid)
		return false
	end
	if (target.flags & MF_NOCLIPTHING)
		return false
	end
	if (target.health <= 0)
		return false
	end
	/*
	if (p and (not ((target.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) and (target.flags & MF_SHOOTABLE)) or (target.flags & MF_SPRING)) == not (target.flags2 & MF2_INVERTAIMABLE)))
		return false
	end
	*/
	if (target.flags2 & MF2_FRET)
		return false
	end
	
	me.angle = R_PointToAngle2(me.x,me.y, target.x,target.y)
	if (p)
		p.drawangle = me.angle
	end
	
	local ns = 0
	--eh forget flipgrav
	local zdist = ((target.z + target.height) - (me.z))
	local dist = FixedHypot(FixedHypot(target.x - me.x, target.y - me.y),zdist)
	dist = max($,1)
	
	if (me.type == MT_DETON and target.player)
		ns = FixedDiv(FixedMul(target.player.normalspeed,target.scale),FixedDiv(20*FU,17*FU))
	elseif (me.type ~= MT_PLAYER)
		if (me.threshold == 32000)
			ns = FixedMul(me.info.speed, me.scale)
		else
			ns = FixedMul(me.info.speed/2, me.scale)
		end
	elseif (p)
		ns = FixedMul(speed, me.scale)
	end
	
	me.momx = FixedMul(FixedDiv(target.x - me.x,dist), ns)
	me.momy = FixedMul(FixedDiv(target.y - me.y,dist), ns)
	me.momz = FixedMul(FixedDiv(zdist,dist), ns)
	return true
end

--thanks katsy for this function
--Bounce checks
function nk.stupidbouncesectors(mobj, sector)
    for fof in sector.ffloors()
        if not (fof.fofflags & FOF_BOUNCY) and (GetSecSpecial(fof.master.frontsector.special, 1) != 15)
            continue
        end
        if not (fof.fofflags & FOF_EXISTS)
            continue
        end
        if (mobj.z+mobj.height+mobj.momz < fof.bottomheight) or (mobj.z-mobj.momz > fof.topheight)
            continue
        end
        return true
    end
end

--Ground Checks, thanks Luigi Budd
function nk.IsPlayerOnGround(me)
local posz = me.floorz
local z = me.z + me.momz
local onPosZ
if (P_MobjFlip(me) == -1)
    posz = me.ceilingz
    z = me.z+me.height + me.momz
    onPosZ = (z >= posz)
else
    onPosZ = (z <= posz)
end
    
if (P_IsObjectOnGround(me) or onPosZ) and (not P_CheckDeathPitCollide(me))
	return true
else
	return false
end
end

addHook("ThinkFrame", function(p)
for p in players.iterate
	if not (p.mo and p.mo.valid) continue end
	if p.mo.skin != nk.skin continue end
	if nk.IsPlayerOnGround(p.mo)
	and p.mo.state != (S_PLAY_FALL or S_PLAY_SPRING or S_NICKSPRINT)
	or p.powers[pw_carry]
		if p.nick_bouncedid
			p.nick_bouncedid = false
		end
		if p.punch_used
			p.punch_used = false
		end
	end
end
end)

--Flip behavior and checks
function nk.FlipChecks(mo, z_adjust)
if P_MobjFlip(mo.target.player.mo) == -1
	local pmo = mo.target.player.mo
	if mo and mo.valid
		mo.flags2 = $|MF2_OBJECTFLIP
		mo.eflags = $|MFE_VERTICALFLIP
		mo.z = ($+FixedMul(mo.target.player.mo.scale, z_adjust))
	end
else
	if mo and mo.valid
		mo.flags2 = $ & ~MF2_OBJECTFLIP
		mo.eflags = $ & ~MFE_VERTICALFLIP
	end
end
end

--VFX Spawning
function nk.SpawnVFX(p, mobjtype, vfxscale, z, color)
if not (p.nick_vfx and p.nick_vfx.valid)
	p.nick_vfx = P_SpawnMobjFromMobj(p.mo, 0,0,(z or 0), mobjtype)
	p.nick_vfx.target = p.mo
	p.nick_vfx.scale = vfxscale
	if color
	and p.nick_vfx.color != color
		p.nick_vfx.color = color
	end
else
	if (p == displayplayer) 
	or (p == secondarydisplayplayer) 
		if not camera.chase
			if p.nick_vfx.valid
				p.nick_vfx.flags2 = $|MF2_DONTDRAW
			end
		else
			if p.nick_vfx and p.nick_vfx.valid
				p.nick_vfx.flags2 = $ & ~MF2_DONTDRAW
			end
		end
	end
end
end

function nk.Thrust(p, movespeed, cap)
	--Better caps to Wolf Buster, thanks Luigi Budd
	local thrust = p.speed + (movespeed*p.mo.scale)
    if thrust > cap*p.mo.scale
        if (p.speed < cap*p.mo.scale)
            thrust = (cap*p.mo.scale - p.speed) + p.speed
        else
            thrust = 0
        end
    end
    if thrust > 0
		if not (p.mo.eflags & MFE_UNDERWATER)
			if not (p.gotflag or p.gotcrystal)
				P_InstaThrust(p.mo, p.mo.angle, thrust)
			else
				P_InstaThrust(p.mo, p.mo.angle, thrust/2)
			end
		else
			P_InstaThrust(p.mo, p.mo.angle, thrust/2)
		end
    else
        P_InstaThrust(p.mo, p.mo.angle,
            R_PointToDist2(0,0, p.mo.momx,p.mo.momy)
        )
    end
end

--Better caps for sprint
function nk.SprintThrust(p, movespeed, cap)
	local speed = FixedHypot(p.rmomx, p.rmomy)
	if speed <= cap*p.mo.scale
		if not (p.mo.eflags & MFE_UNDERWATER)
			if not (p.gotflag or p.gotcrystal)
				P_Thrust(p.mo, p.mo.angle, movespeed*p.mo.scale)
			else
				P_Thrust(p.mo, p.mo.angle, (movespeed/2)*p.mo.scale)
			end
		else
			P_Thrust(p.mo, p.mo.angle, (movespeed/2)*p.mo.scale)
		end
	end
end

--State checks
function nk.StatesCheck(mo, state_start, state_end)
	if not (mo and mo.valid and mo.player and mo.player.mo.skin == nk.skin) return end
	if state_end
		return (mo.state >= state_start	and mo.state <= state_end)
	else
		return mo.state == state_start
	end
end