--Thanks to TwoTailedHero (Miles Prower) AKA. Gordon Freeman dev for this code ;)

local nk = Nick

local function isConstantFreeslotted(name)
    return pcall(function()
        local _ = _G[name]
    end)
end

local curHooks = {}    -- guard table so each hook only ever installs once

-- 1) caption utility & Adventure-Style rank setup

local function FreeSlotAndCaption(...)
    local args = {...}
    for i = 1, #args, 2 do
        local slotName, caption = args[i], args[i+1]
        if not _G[slotName] then
            local slotID = freeslot(slotName)
            if caption then
                sfxinfo[slotID].caption = caption
            end
        end
    end
end

-- Preload all the voice slots + captions
FreeSlotAndCaption(
    "sfx_nkrnke", "Crap!",
    "sfx_nkrnkd", "How boring...",
    "sfx_nkrnkc", "Hm..",
    "sfx_nkrnkb", "Beated pal",
    "sfx_nkrnka", "Gotcha!"
)

-- voice-line lookup by skin + rank
local ranktalks = {
    nick = { 
		E=sfx_nkrnke, 
		D=sfx_nkrnkd, 
		C=sfx_nkrnkc,
        B=sfx_nkrnkb, 
		A=sfx_nkrnka 
	},
}

-- Adventure Style Rank Quotes

local function TryInstallAdventureRank()
    if not curHooks.adventureRank
    and Style_Pack_Active
    and Style_AdventureVersion
    and Style_AdventureVersion > 3250
    then
        curHooks.adventureRank = true

        local API = tbsrequire("styles_api")

        -- reset our flag each tally
        API:event("TallySetup", function(player)
            player.nickhasranked = false
        end)

        -- fire once when the results-screen timer first ticks
       	
        API:event("RankSetup", function(player, rank)
            if player.styles_tallytimer == (TICRATE + 1) and not player.nickhasranked then -- TODO: Maybe remove the "+1" if it works with just TICRATE?? This internal hook order SRB2 has kinda stank...
                local skin = player.mo.skin
                local talk = ranktalks[skin] and ranktalks[skin][rank]
                if talk then
                    -- Only randomize if non-table
                    if type(talk)=="table" then
                        talk = talk[ A_RandomRange(1,#talk) ]
                    end
                    S_StartSound(nil, talk, player)
                end
            end
        end)
        
        addHook("PlayerThink", function(player)
            -- make sure we dont get rudely interrupted
            if player.styles_tallytimer == TICRATE and not player.nickhasranked then
                player.styles_tallytimer = $ + (TICRATE * 2/3)
                player.nickhasranked = true
            end
        end)
        print("\130Nick WolfFang setted up for Adventure-Styles")
    end
end

-- run immediately, and again on every AddonLoaded event
TryInstallAdventureRank()
addHook("AddonLoaded", TryInstallAdventureRank)