local nk = Nick
local BMVFX_Added = false

nk.makeBattlemodVFX = function()

/*------------------------Stomp Buster-------------------------*/

freeslot("SPR_NICK_STOMPBUSTER", "MT_NICK_STOMPBOOST", "S_NICK_STOMPBOOST")

states[S_NICK_STOMPBOOST] = {SPR_NICK_STOMPBUSTER, FF_FULLBRIGHT|FF_ADD|FF_ANIMATE|A, -1, nil, 2, 2, S_NICK_STOMPBOOST}

mobjinfo[MT_NICK_STOMPBOOST] = {
	doomednum = -1,
	spawnstate = S_NICK_STOMPBOOST,
	spawnhealth = 100,
	speed = 0,
    radius = 50*FRACUNIT,
    height = 50*FRACUNIT,
    mass = 1,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_FLOAT|MF_NOCLIPHEIGHT
}

local StompBusterVFX = function(mo)

	local target = mo.target
	if not (mo and mo.valid) then
		return
	end

	if not (mo.target
	and mo.target.valid
	and mo.target.player)
	or target.player.mo.state != S_NICK_BM_STOMPBUSTER then
		P_RemoveMobj(mo)
		return
	end

	local x, y = cos(mo.target.player.drawangle),sin(mo.target.player.drawangle)

	P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	
	local boostghost = P_SpawnGhostMobj(mo)
	P_MoveOrigin(boostghost,mo.x,mo.y,mo.z)
	boostghost.fuse = 4
	boostghost.dispoffset = 50
	
	local p = target.player
	
	if not G_GametypeHasTeams()
		if not (mo.target.player.powers[pw_shield] & SH_NOSTACK == SH_WHIRLWIND)
			if not p.nick_powerscolor
				if p.nick_wblevel == 1 and mo.color != SKINCOLOR_CERULEAN
						mo.color = SKINCOLOR_CERULEAN
				elseif p.nick_wblevel == 2 and mo.color != SKINCOLOR_ORANGE
					mo.color = SKINCOLOR_ORANGE
				elseif p.nick_wblevel == 3 and mo.color != SKINCOLOR_RED
					mo.color = SKINCOLOR_RED
				elseif p.nick_wblevel == 4 and mo.color != SKINCOLOR_PURPLE
					mo.color = SKINCOLOR_PURPLE
				end
			elseif mo.color != p.nick_powerscolor
				mo.color = p.nick_powerscolor
			end
		elseif mo.color != SKINCOLOR_CARBON
			mo.color = SKINCOLOR_CARBON
		end
	elseif mo.color != p.mo.color
		mo.color = p.mo.color
	end
	if p.nick_wblevel >= 3
		mo.anim_duration = 1
	end
	
	mo.dispoffset = 0
	boostghost.dispoffset = 50
	nk.FlipChecks(mo, -11*FU)
end

/*------------------------Buster Charge-------------------------*/

freeslot("SPR_NICK_WBCHARGE", "MT_NICK_WBCHARGE", "S_NICK_WBCHARGE", "S_NICK_WBREADY")

states[S_NICK_WBCHARGE] = {SPR_NICK_WBCHARGE, FF_FULLBRIGHT|FF_ADD|FF_ANIMATE|A, -1, nil, 3, 2, S_NICK_WBCHARGE}
states[S_NICK_WBREADY] = {SPR_NICK_WBCHARGE, FF_FULLBRIGHT|FF_ADD|FF_ANIMATE|4, 12, nil, 2, 4, S_NULL}

mobjinfo[MT_NICK_WBCHARGE] = {
	doomednum = -1,
	spawnstate = S_NICK_WBCHARGE,
	deathstate = S_NICK_WBREADY,
	spawnhealth = 100,
	speed = 0,
    radius = 50*FRACUNIT,
    height = 50*FRACUNIT,
    mass = 1,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_FLOAT|MF_NOCLIPHEIGHT
}

local WB_Charge = function(mo)
	local target = mo.target
	if not (mo and mo.valid) then
		return
	end

	if not (mo.target
	and mo.target.valid
	and mo.target.player)
	or not target.player.nick_wbcharge
	--and not target.player.nick_wbcharge == nk.battle.WB_maxtime
		P_RemoveMobj(mo)
		return
	end
	
	local p = target.player
	
	if p.nick_wbcharge <= nk.battle.WB_steps 
	and mo.color != SKINCOLOR_CERULEAN
		mo.color = SKINCOLOR_CERULEAN
	elseif p.nick_wbcharge > nk.battle.WB_steps and p.nick_wbcharge <= nk.battle.WB_steps*2
	and mo.color != SKINCOLOR_ORANGE
		mo.color = SKINCOLOR_ORANGE
	elseif p.nick_wbcharge > nk.battle.WB_steps*2 and p.nick_wbcharge <= nk.battle.WB_steps*3
	and mo.color != SKINCOLOR_RED
		mo.color = SKINCOLOR_RED
	elseif p.nick_wbcharge == nk.battle.WB_maxtime
	and mo.color != SKINCOLOR_PURPLE
		mo.color = SKINCOLOR_PURPLE
	end
	
	if p.nick_wbcharge > nk.battle.WB_steps*2 and p.nick_wbcharge < nk.battle.WB_maxtime
	and (mo.state != S_NICK_WBREADY)
		mo.anim_duration = 1
		local ghost = P_SpawnGhostMobj(mo)
		P_MoveOrigin(ghost,mo.x,mo.y,mo.z)
	end
	if p.nick_wbcharge == nk.battle.WB_maxtime
	and mo.state != S_NICK_WBREADY
		mo.state = S_NICK_WBREADY
		mo.scale = p.mo.scale*3/2
		mo.wbready = true
	end
	
	P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	nk.FlipChecks(mo, 8*FU)
	mo.dispoffset = 50
end

/*------------------------Stomp Crater-------------------------*/

freeslot("SPR_NICK_CRATER", "MT_NICK_CRATER", "S_NICK_CRATER", "S_NICK_CRATER_BIG")
states[S_NICK_CRATER] = {SPR_NICK_CRATER, FF_PAPERSPRITE|FF_FLOORSPRITE|A, 2*TICRATE, nil, 0, 0, S_NULL}

mobjinfo[MT_NICK_CRATER] = {
	doomednum = -1,
	spawnstate = S_NICK_CRATER,
	spawnhealth = 100,
	speed = 0,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    mass = 1,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_FLOAT
}

/*------------------------Breaker Punch VFX-------------------------*/

freeslot("SPR_NICK_WHIRLPUNCH", "MT_NICK_WHIRLPUNCH", "S_NICK_WHIRLPUNCH")
states[S_NICK_WHIRLPUNCH] = {SPR_NICK_WHIRLPUNCH, FF_FLOORSPRITE|FF_ANIMATE|FF_FULLBRIGHT|FF_ADD, -1, nil, 3, 1, S_NULL}

mobjinfo[MT_NICK_WHIRLPUNCH] = {
	doomednum = -1,
	spawnstate = S_NICK_WHIRLPUNCH,
	spawnhealth = 100,
	speed = 0,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    mass = 1,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_FLOAT
}

local WhirlPunchVFX = function(mo)
	local target = mo.target
	if not (mo and mo.valid) then
		return
	end

	if not (mo.target
	and mo.target.valid
	and mo.target.player)
	or mo.target.state != S_NICK_BM_PUNCH
		P_RemoveMobj(mo)
		return
	end
	
	local p = target.player
	
	if not G_GametypeHasTeams()
		if not p.nick_powerscolor
			if mo.color != SKINCOLOR_GALAXY
				mo.color = SKINCOLOR_GALAXY
			end
		else
			if mo.color != p.nick_powerscolor
				mo.color = p.nick_powerscolor
			end
		end
	else
		if mo.color != target.color
			mo.color = target.color
		end
	end
	
	nk.FlipChecks(mo, 0)
	P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z+((p.mo.height/2)+(9*p.mo.scale)))
end

addHook("MobjThinker", StompBusterVFX, MT_NICK_STOMPBOOST)
addHook("MobjThinker", WB_Charge, MT_NICK_WBCHARGE)
addHook("MobjThinker", WhirlPunchVFX, MT_NICK_WHIRLPUNCH)
end

-- this is a really bad fix for the sprites not freeslotting but
-- i mean what else can you do here as a modder yknow
nk.makeBattlemodVFX()