local nk = Nick
local BMSet_Added = false

local function AddBattleSet()
	if BMSet_Added then return end
	local B = CBW_Battle
	if not B then return end
	
	--balancing values. adjustable through external patches
	local nkb = nk.battle
	nk.Slide_strongspeed = 29
	nkb.WB_maxtime = TICRATE-3
	nkb.homingcdtimer = TICRATE+15
	nkb.homingspeed = 36
	nkb.WB_thrustdivider = 0 -- in case WB's thrust is too fast
	nkb.punchdelay = 6
	nkb.breakerknockback = 5
	NICK_THRUSTCAP_SPRINT = 40
	NICK_KNOCKBACKACTIVATION = 25*FU
	
	nk.WB_low_speed = 25
	nk.WB_medium_speed = 35
	nk.WB_high_speed = 45
	NICK_THRUSTCAP = 55
	
	--err, don't touch this lol
	nkb.WB_steps = nkb.WB_maxtime/3 --4 power levels. maxtime is the maximum power
	
	freeslot("sfx_nckbjm", "sfx_nkchrg", "sfx_nkatk1", "sfx_nkatk2", "sfx_nkvc1", "sfx_nkvc2",
			 "SPR2_PSTP", "SPR2_STMP", "SPR2_PNCH")
	spr2defaults[SPR2_PNCH] = SPR2_CLMB
	spr2defaults[SPR2_PSTP] = SPR2_ROLL
	spr2defaults[SPR2_STMP] = SPR2_FALL
			 
	freeslot("S_NICK_BM_PUNCH", "S_NICK_BM_PREPUNCH")
	states[S_NICK_BM_PREPUNCH] = {SPR_PLAY, SPR2_PNCH, -1, nil, 0, 0, S_NICK_BM_PUNCH}
	states[S_NICK_BM_PUNCH] = {SPR_PLAY, SPR2_PNCH|FF_ANIMATE, 24, nil, 12, 2, S_PLAY_FALL}
	
	freeslot("S_NICK_BM_STOMPBUSTER", "S_NICK_BM_PRESTOMPBUSTER")
	states[S_NICK_BM_PRESTOMPBUSTER] = {SPR_PLAY, SPR2_PSTP, -1, nil, 0, 0, S_NICK_BM_PRESTOMPBUSTER}
	states[S_NICK_BM_STOMPBUSTER] = {SPR_PLAY, SPR2_STMP, -1, nil, 0, 0, S_NICK_BM_STOMPBUSTER}
	
	local NickCanAct = function(mo)
		local p = mo.player
		if (P_PlayerInPain(p) or (CBW_Battle and (p.tumble != nil and p.tumble > 0))
		or p.playerstate == PST_DEAD or p.mo.state == S_PLAY_PAIN or p.mo.sprite2 == SPR2_PAIN)
		and p.powers[pw_carry]
			return false
		else return true
		end
	end
	
	local NickBM_ResetValues = function(mo)
		local p = mo.player
		if (p.nick_wbcharge 
		or p.nick_premomentum 
		or p.nick_sb_premomentum 
		or p.nick_wblevel
		or p.nick_bm_recovered
		or p.nick_stomplaunch)
			p.nick_wbcharge = 0
			p.nick_premomentum = false
			p.nick_sb_premomentum = false
			if not p.nick_stomplaunch
				p.nick_wblevel = 0
			end
			p.nick_bm_recovered = false
			if p.actionstate == 0
				p.nick_stomplaunch = false
			end
		end
	end
	
	local function Nick_CanHurtPlayer(p1,p2, noinvulns)
		if not (p1 and p1.valid)
		or not (p2 and p2.valid)
			return false
		end
		
		if (B and B.BattleGametype())
			if B.MyTeam(p1,p2)
				return false
			end
			
			if ((p2.powers[pw_flashing])
			or (p2.powers[pw_invulnerability])
			or (p2.powers[pw_super]))
			and not noinvulns
				return false
			end
			
			if (p1.botleader == p2)
				return false
			end
			
			if not B.PlayerCanBeDamaged(p2)
			and not noinvulns
				return false
			end
			
			return true
		end
	end
	local function Nick_CanHurtObject(p1,p2, noinvulns)
		if not (p1 and p1.valid)
		or not (p2 and p2.valid)
			return false
		end
		
		if (B and B.BattleGametype())
			return true
		end
	end
	
	local function Nick_ZCollide(mo1,mo2)
		if (mo1.z > mo2.z + mo2.height) then return false; end
		if (mo2.z > mo1.z + mo1.height) then return false; end
		return true
	end
	
	local function Nick_Hitbox(p, range)
		local me = p.mo
		if not (me and me.valid) then return end
		
		local fakerange = (range > 126*FU) and 256*FU or 126*FU
		searchBlockmap("objects", function(ref, found)
			if found == me then return end
			if not (found.health) then return end
			if not P_CheckSight(me,found) then return end
			if (found.flags & (MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING)) then return end
			if not ((found.player and found.player.valid) or (found == B.TrainingDummy and found.valid)) then return end
			if (found.player and found.player.airdodge ~= nil and found.player.airdodge > 0) then return end
			if (found.player and found.player.intangible) then return end
			
			local this_range = (found.flags & MF_MISSILE) and (range + 16*found.scale) or range
			if abs(me.x - found.x) > this_range + found.radius
			or abs(me.y - found.y) > this_range + found.radius
				return
			end
			if not Nick_ZCollide(me,found) then return end
			
			if Nick_CanHurtPlayer(p,found.player)
				if p.nick_stomplaunch and nk.IsPlayerOnGround(p.mo)
					B.DoPlayerTumble(found.player,TICRATE*3/2,
						R_PointToAngle2(p.mo.x,p.mo.y,
						found.x,found.y
						), 0
					)
				else
					B.PlayerTouch(me, found)
				end
				return
			end
			if Nick_CanHurtObject(p,found)
				if not (p.nick_stomplaunch and nk.IsPlayerOnGround(p.mo))
					B.BashableCollision(found, me)
				end
				return
			end
		end, 
		me,
		me.x-fakerange, me.x+fakerange,
		me.y-fakerange, me.y+fakerange)
	end
	
	--The Main actions function
	local NickActions = function(mo,doaction)
		local p = mo.player
		local cmd = mo.player.cmd
		
		if not(B.CanDoAction(p)) then p.actionstate = 0 return end
		
		--Hitbox
		if (p.actionstate == 1 and p.mo.state == S_NICK_BM_PUNCH)
			Nick_Hitbox(p,
				mo.radius * 3
			)
		elseif p.actionstate == 2 and p.nick_stomplaunch
			if not nk.IsPlayerOnGround(p.mo)
				Nick_Hitbox(p,
					mo.radius * 3
				)
			else
				Nick_Hitbox(p,
					mo.radius*max((3*p.nick_wblevel), 4)
				)
			end
		elseif p.punch_used and mo.state == S_PLAY_CLING
			Nick_Hitbox(p,
				mo.radius * 2
			)
		end
		
		--Rings ability names and costs
		if nk.IsPlayerOnGround(p.mo)
			p.actiontext = "Breaker Punch"
			p.actionrings = 10
		else
			if not p.punch_used
			or (p.mo.state != S_PLAY_CLIMB)
				p.actiontext = "Stomp Buster"
				if (cmd.buttons & BT_ATTACK)
				and not ((p.mo.state == S_PLAY_CLING)
				or p.nick_premomentum 
				or p.nick_bm_recovered)
				and p.actionstate == 2
					p.action2text = "Jump: Recover"
				end
				p.actionrings = 15
			end
		end
		
		--Neutral action
		if p.actionstate == 0
			if doaction == 1
				if nk.IsPlayerOnGround(p.mo)
					if not p.mo.nickslidecheck
						p.actionstate = 1
						p.actiontime = 0
						B.PayRings(p)
					end
				elseif (p.mo.state != S_PLAY_CLIMB)
					if not ((p.mo.state == S_PLAY_CLING) or p.nick_premomentum)
						p.actionstate = 2
						p.actiontime = 0
					end
				end
				p.actiontime = 0
			end
		--Breaker Punch
		elseif p.actionstate == 1
			p.actiontime = $+1
			--Delay
			if p.actiontime < nkb.punchdelay
				p.powers[pw_nocontrol] = 1
				if p.mo.state != S_NICK_BM_PREPUNCH
					p.mo.state = S_NICK_BM_PREPUNCH
					S_StartSound(p.mo, sfx_nkchrg)
					S_StartSound(p.mo, P_RandomRange(sfx_nkvc1, sfx_nkvc2))
					B.ApplyCooldown(p,4*TICRATE)
				end
			elseif p.actiontime >= nkb.punchdelay
			--Attack
				p.powers[pw_nocontrol] = 1
				if p.mo.state != S_NICK_BM_PUNCH
					p.mo.state = S_NICK_BM_PUNCH
						nk.SpawnVFX(p,
						MT_NICK_WHIRLPUNCH, 
						p.mo.scale*3/2, 
						(p.mo.height/2)+(9*p.mo.scale), 
						(G_GametypeHasTeams() and mo.color) or p.nick_powerscolor or SKINCOLOR_GALAXY)
					P_InstaThrust(p.mo, p.mo.angle, p.speed+(20*p.mo.scale))
					P_SetObjectMomZ(p.mo, 3*FU, false)
				else
					p.panim = PA_DASH
					if p.actiontime == nkb.punchdelay+2 or p.actiontime == nkb.punchdelay+12
						S_StartSound(p.mo, P_RandomRange(sfx_nkatk1, sfx_nkatk2))
					end
				end
				if p.actiontime >= nkb.punchdelay+20
					p.actiontime = 0
					p.actionstate = 0
					p.powers[pw_nocontrol] = 0
				end
			end
		--Stomp Buster
		elseif p.actionstate == 2
			p.actiontime = $+1
			--same formula as Wolf buster
			if not nk.IsPlayerOnGround(p.mo)
			and NickCanAct(p.mo)
				--Pre stomp buster
				if ((cmd.buttons & BT_ATTACK) or p.nick_sbdelay)
				and not p.nick_bm_recovered
				and not (p.gotflag or p.gotcrystal)
					if p.nick_wbcharge < nkb.WB_maxtime
					and not p.nick_stomplaunch
						p.nick_wbcharge = $+1
						if not p.nick_sb_premomentum
							p.mo.momx = $/2
							p.mo.momy = $/2
							p.mo.state = S_NICK_BM_PRESTOMPBUSTER
							P_SetObjectMomZ(p.mo, 7*p.mo.scale, false)
							S_StartSound(p.mo, sfx_s1bb)
							p.nick_sb_premomentum = true
							p.nick_sbdelay = 10
						end
						if p.nick_wbcharge == nkb.WB_maxtime
							S_StartSound(p.mo, sfx_s3k41, p)
						end
					end
					if p.nick_sb_premomentum
						p.mo.momz = $ - P_GetMobjGravity(p.mo) / 4
					end
					if (cmd.buttons & BT_JUMP)
					and not (p.lastbuttons & BT_JUMP)
					-- Pressed jump? grants a recovery!
					and not p.nick_bm_recovered
					and not nk.IsPlayerOnGround(p.mo)
						p.mo.state = S_PLAY_ROLL
						S_StartSound(p.mo, sfx_nckbjm)
						if p.cmd.forwardmove
							P_InstaThrust(p.mo, p.mo.angle, 17*mo.scale)
						end
						if p.nick_wbcharge <= nkb.WB_steps
							p.nick_wblevel = 1
						elseif p.nick_wbcharge > nkb.WB_steps and p.nick_wbcharge <= nkb.WB_steps*2
							p.nick_wblevel = 2
						elseif p.nick_wbcharge > nkb.WB_steps*2 and p.nick_wbcharge <= nkb.WB_steps*3
							p.nick_wblevel = 3
						elseif p.nick_wbcharge > nkb.WB_steps*3
							p.nick_wblevel = 4
						end
						P_SetObjectMomZ(p.mo, (4*mo.scale)*p.nick_wblevel, false)
						for i = 1, 12
							local dust = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
							dust.angle = ANG30*i
							dust.flags = $|MF_SCENERY
							dust.frame = $|FF_TRANS50
							P_InstaThrust(dust, dust.angle, 16*dust.scale)
							P_Thrust(dust, p.mo.angle, p.speed/2)
						end
						p.nick_sb_premomentum = false
						p.nick_wbcharge = 0
						B.ApplyCooldown(p,1*TICRATE)
						B.PayRings(p)
						p.nick_bm_recovered = true
						p.nick_recoverroll_tics = TICRATE/3
					end
				elseif p.nick_wbcharge
				and not p.nick_sbdelay
				and not p.nick_stomplaunch
					p.mo.state = S_NICK_BM_STOMPBUSTER
					p.mo.momx = 0
					p.mo.momy = 0
					P_SetObjectMomZ(p.mo, -22*FU, false)
					S_StartSound(p.mo, sfx_s3k61)
					p.nick_sb_premomentum = false
					if p.nick_wbcharge <= nkb.WB_steps
						p.nick_wblevel = 1
						B.ApplyCooldown(p,1*TICRATE)
					elseif p.nick_wbcharge > nkb.WB_steps and p.nick_wbcharge <= nkb.WB_steps*2
						p.nick_wblevel = 2
						B.ApplyCooldown(p,2*TICRATE)
					elseif p.nick_wbcharge > nkb.WB_steps*2 and p.nick_wbcharge <= nkb.WB_steps*3
						p.nick_wblevel = 3
						B.ApplyCooldown(p,2*TICRATE)
					elseif p.nick_wbcharge > nkb.WB_steps*3
						p.nick_wblevel = 4
						B.ApplyCooldown(p,3*TICRATE)
					end
					p.nick_wbcharge = 0
					B.PayRings(p)
					p.nick_stomplaunch = true
				end
				if p.nick_stomplaunch
					nk.SpawnVFX(p, 
					MT_NICK_STOMPBOOST, 
					p.mo.scale*3/2,
					0,
					(G_GametypeHasTeams() and mo.color) or p.nick_powerscolor or 
					(p.nick_wblevel == 1 and SKINCOLOR_CERULEAN) or
					(p.nick_wblevel == 2 and SKINCOLOR_ORANGE) or
					(p.nick_wblevel == 3 and SKINCOLOR_RED) or
					(p.nick_wblevel == 4 and SKINCOLOR_PURPLE)
					)
				end
				
				if p.nick_recoverroll_tics
					p.nick_recoverroll_tics = $-1
				end
				if p.nick_bm_recovered
				and p.mo.state == S_PLAY_ROLL
				and not p.nick_recoverroll_tics
					p.mo.state = S_PLAY_FALL
				end
			elseif p.nick_bm_recovered or not p.nick_stomplaunch
				p.actionstate = 0
			end
		--stomp on land
			if nk.IsPlayerOnGround(p.mo)
			and (p.mo.eflags & MFE_JUSTHITFLOOR)
			and p.nick_stomplaunch
				S_StartSound(p.mo, sfx_s3k5f)
				local crater = P_SpawnMobjFromMobj(p.mo, 0,0,0, MT_NICK_CRATER)
				crater.scale = p.mo.scale*(min(2*p.nick_wblevel, 6))
				crater.renderflags = $|RF_NOSPLATBILLBOARD
				if p.nick_wblevel >= 3
					crater.frame = FF_PAPERSPRITE|FF_FLOORSPRITE|1
				end
				P_StartQuake((15*p.mo.scale)*p.nick_wblevel,
							TICRATE/2, 
							{mo.x, mo.y, mo.z},
							(30*mo.scale)*p.nick_wblevel)
				p.nick_stomplaunch = false
			end
		end
	end
	
	local NickPriority = function(p)
		-- Whirl Punch
		if p.actionstate == 1
			B.SetPriority(p,
				2,2,
				"can_damage",
				2,2,
				"Breaker Punch"
			)
		end
		
		-- Slide and strong slide
		if p.mo.state == S_PLAY_NICKSLIDE 
			local speed = FixedHypot(p.rmomx, p.rmomy)
			local strong = speed >= nk.Slide_strongspeed*p.mo.scale
			B.SetPriority(p,
				1,1,
				"knuckles_glide",
				-- sweet spot
				strong and 2 or 1, strong and 3 or 1,
				"Wolf Slide"
			)
		-- Slide Jump
		elseif p.mo.state == S_PLAY_ROLL and p.mo.nickslidejump
			B.SetPriority(p,
				1,1,
				nil,
				1,1,
				"Rolling Jump"
			)
		--WolfBuster
		elseif p.mo.state == S_PLAY_CLING
		if not (p.gotflag or p.gotcrystal)
			if p.nick_wblevel == 1
				B.SetPriority(p,
					1,1,
					"knuckles_glide",
					1,2,
					"Wolf Buster lvl.1"
				)
			elseif p.nick_wblevel == 2
				B.SetPriority(p,
					1,2,
					"knuckles_glide",
					1,2,
					"Wolf Buster lvl.2"
				)
			elseif p.nick_wblevel == 3
				B.SetPriority(p,
					1,2,
					"knuckles_glide",
					2,2,
					"Wolf Buster lvl.3"
				)
			elseif p.nick_wblevel == 4
				B.SetPriority(p,
					2,2,
					"knuckles_glide",
					3,2,
					"Wolf Buster lvl.4"
				)
			end
		else
			B.SetPriority(p,
				1,1,
				"knuckles_glide",
				1,2,
				"half Wolf Buster"
			)
		end
		elseif p.mo.state == S_PLAY_CLIMB and p.kickdid
			B.SetPriority(p,
				1,1,
				nil,
				1,1,
				"homing kick"
			)
		--Stomp Buster
		elseif p.nick_stomplaunch
			if p.nick_wblevel == 1
				B.SetPriority(p,1,1,nil,1,2,"Stomp Buster lvl.1")
			elseif p.nick_wblevel == 2
				B.SetPriority(p,1,2,nil,2,1,"Stomp Buster lvl.2")
			elseif p.nick_wblevel == 3
				B.SetPriority(p,1,2,nil,2,2,"Stomp Buster lvl.3")
			elseif p.nick_wblevel == 4
				B.SetPriority(p,2,2,nil,3,2,"Stomp Buster lvl.4")
			end
		end
	end
	
	local CollideFunc = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
		if mo[n1].state == S_PLAY_CLIMB and mo[n1].player.kickdid
			if not ((hurt != 1 and n1 == 1) or (hurt != -1 and n1 == 2))
				if not mo[n1].nick_homingcheck
					mo[n1].nick_homingcheck = true
				end
			else
				mo[n1].state = S_PLAY_FALL
				P_SetObjectMomZ(mo[n1], -8*mo[n1].scale, false)
				mo[n1].momx = $/6
				mo[n1].momy = $/6
			end
		end
		if mo[n1].state == S_PLAY_CLING and mo[n1].player.punch_used
			if ((mo and not mo.player) or not ((hurt != 1 and n1 == 1) or (hurt != -1 and n1 == 2)))
				mo[n1].momx = $/4
				mo[n1].momy = $/4
				mo[n1].state = S_PLAY_FALL
			end
		end
		if mo[n1].player.nick_wbcharge
			NickBM_ResetValues(mo[n1])
		end
		if mo[n1].player.nick_stomplaunch
			if not mo[n2].player
				P_SetObjectMomZ(mo[n1], -8*mo[n1].scale, false)
				mo[n1].state = S_PLAY_FALL
				mo[n1].player.nick_stomplaunch = false
				mo[n1].player.actionstate = 0
				return false
			else
				return true
			end
		end
		if mo[n1].player.actionstate == 1 and mo[n1].state == S_NICK_BM_PUNCH
		and not ((hurt != 1 and n1 == 1) or (hurt != -1 and n1 == 2))
			local angle = R_PointToAngle2(mo[n1].x, mo[n1].y, mo[n2].x, mo[n2].y)
			P_InstaThrust(mo[n2], angle, (mo[n1].player.speed/(2+(1/2)))+(nkb.breakerknockback*mo[n1].scale))
			return true
		end
		if mo[n1].nickslidecheck
			return true
		end
	end
	
	B.SkinVars["nick"] = {
		flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
		weight = 120,
		shields = 1,
		guard_frame = 2,
		special = NickActions,
		func_priority_ext = NickPriority,
		func_collide = CollideFunc,
		sprites = {
			S_NICK_BM_PUNCH
		},
	}
	
	local function BM_DoWolfBuster(p)
		p.mo.state = S_PLAY_CLING
		p.mo.momz = 0
		S_StartSound(p.mo, sfx_spratk)
		p.pflags = $ |PF_JUMPED|PF_THOKKED
		p.punch_used = true
		p.kickdid = true
		p.dash_used = true
		p.cannot_nickusekick = true
		p.canceltimer = 1
	end
	
	--UUHHGHGHHHHH WHY ISNT THIS GLOBAL
	local function LookForThingsThatICanHit(player)
		local pmo = player.mo
		local twod = (twodlevel or player.mo.flags2 & MF2_TWOD)
		local ringdist, span
		if not(twod)
			ringdist = RING_DIST*2
			span = ANG60
		else
			ringdist = RING_DIST
			span = FixedAngle(40*FU)
		end

		local maxdist = FixedMul(ringdist, player.mo.scale)
		local closestdist = 0
		local closestmo = nil
		
		--local function in local function, probably bad practice for this game
		--but i really wanna keep code size small
		--this is battlemod code btw from its gunslinger
		local function Wrapper(_,mo)
			if (mo.flags & MF_NOCLIPTHING) return end
			if (mo.health <= 0) return end -- dead
			
			if not(mo.player)
			and (!((mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)
			and (mo.flags & MF_SHOOTABLE)) or (mo.flags & MF_SPRING)) == !(mo.flags2 & MF2_INVERTAIMABLE)) -- allows if it has the flags desired XOR it has the invert aimable flag
				return -- not a valid target
			end
			--CTF monitor 
			if mo.type == MT_RING_REDBOX and not(G_GametypeHasTeams() and player.ctfteam == 1) then return end
			if mo.type == MT_RING_BLUEBOX and not(G_GametypeHasTeams() and player.ctfteam == 2) then return end
			
			if (mo == pmo) return end
			if (mo.flags2 & MF2_FRET) return end
			if (mo.type == MT_TARGETDUMMY) return end --We won't be relying on this for player detection
			if (mo.player and (B.MyTeam(player,mo.player) or mo.player.spectator)) then return end --Disallow targeting teammates
			if (mo.player and mo.player.intangible) then return end--Disallow targeting air dodge
			
			--Do angle/distance checks
			local zdist = (pmo.z + pmo.height/2) - (mo.z + mo.height/2)
			local dist = P_AproxDistance(pmo.x-mo.x, pmo.y-mo.y)
			--CBW: 	Made the angle checks their own locals, for readability purposes
			--		I also unsigned the angle checks, which appears to correct failed OutOfBounds checks above the player.
			local xyz_angle = abs(R_PointToAngle2(0, 0, dist, zdist))
			local xy_angle = abs(R_PointToAngle2(
					pmo.x + P_ReturnThrustX(pmo, pmo.angle, pmo.radius),
					pmo.y + P_ReturnThrustY(pmo, pmo.angle, pmo.radius),
					mo.x, mo.y
				) - pmo.angle)
				
				
			dist = P_AproxDistance(dist, zdist)
			if (dist > maxdist)
				return -- out of range
			end
			if (xyz_angle > span)
				return -- Don't home outside of desired angle!
			end
			
			if (twod
			and abs(pmo.y-mo.y) > pmo.radius)
				return -- not in your 2d plane
			end
			
			if ((closestmo and closestmo.valid) and (dist > closestdist))
				return
			end
			if (xy_angle > span)
				return -- behind back
			end
			
			if not (P_CheckSight(pmo, mo))
				return -- out of sight
			end
			
			closestmo = mo
			closestdist = dist
		end
		
		searchBlockmap("objects",Wrapper,player.mo,player.mo.x-maxdist,player.mo.x+maxdist,player.mo.y-maxdist,player.mo.y+maxdist)
		for play in players.iterate
			if not (play.mo and play.mo.valid) then continue end
			Wrapper(nil,play.mo)
		end
		return closestmo
	end
	
	local BATTLE = function(p)
		--Bruh
		if p.mo and p.mo.skin == nk.skin
		and not nk.gamemodes()
		and CBW_Battle
			if not (B.TagGametype() and not (p.battletagIT or (p.pflags&PF_TAGIT)))
			local cmd = p.cmd
			local mo = p.mo
			
			if p.nick_wbcharge == nil
				p.nick_wbcharge = 0
			end
			
			--Spawn charging Wolf/Stomp Buster VFX
			if p.nick_wbcharge > 0 and p.nick_wbcharge < nkb.WB_maxtime
			and not p.nick_stomplaunch
				nk.SpawnVFX(p, MT_NICK_WBCHARGE, p.mo.scale)
			end
			
			if p.nick_stomplaunch and ((p.mo.eflags & MFE_SPRUNG))
				p.nick_stomplaunch = false
			end
			if p.nick_wbdelay
				p.nick_wbdelay = $-1
			end
			if p.nick_sbdelay
				p.nick_sbdelay = $-1
			end
		
			if (nk.IsPlayerOnGround(p.mo) or not NickCanAct(p.mo)) --reset any aerial abilities values
				NickBM_ResetValues(p.mo)
			end
			
			if not (p.nick_bouncedid or p.mo.state == S_PLAY_CLING)
			and (p.pflags & PF_JUMPED)
			and not p.powers[pw_carry]
			and not nk.IsPlayerOnGround(mo)
			and not p.kickdid
			and not p.actionstate
			and not (p.gotflag or p.gotcrystal)
			and not p.nick_homingcd
			and not (p.nick_wbcharge)
				p.enemytarget = LookForThingsThatICanHit(p)
				if p.enemytarget and p.enemytarget.valid
					p.enemydistance = R_PointToDist2(p.mo.x, p.mo.y, p.enemytarget.x, p.enemytarget.y)
					p.enemydistance2 = R_PointToDist2(p.mo.z, p.mo.z, p.enemytarget.z, p.enemytarget.z)
				end
				if not (p.powers[pw_shield] & SH_NOSTACK == SH_ATTRACT)
					local t = p.enemytarget
					if t and t.valid
						local tdist = p.enemydistance
						local tdist2 = p.enemydistance2
						if (tdist or tdist2) and (tdist <= NICK_HOMINGDISTANCE and tdist2 <= NICK_HOMINGDISTANCE)
							P_SpawnLockOn(p, t, S_LOCKON1)
						end
					end
				end
			end
			
			--Fixes Wall Bounce not working on BattleMod
			if (p.punch_used and mo.state == S_PLAY_CLING)
			and not p.ledgegrabcooldown
				p.ledgegrabcooldown = 1
			end
			
			if (P_IsObjectOnGround(p.mo) and P_CheckDeathPitCollide(p.mo))
			and p.nick_stomplaunch
				p.nick_stomplaunch = false
			end
			
			if not nk.IsPlayerOnGround(p.mo)
			and (p.pflags & PF_JUMPED)
			and not p.punch_used
			and not p.actionstate
			and (p.mo.state != S_PLAY_CLIMB)
			--Wolf Buster
				if not p.nick_premomentum
					p.nick_premomentum = false
				end
				
				if ((cmd.buttons & BT_SPIN) or p.nick_wbdelay)
				and not p.powers[pw_carry]
				--and not (p.gotflag or p.gotcrystal)
				and not p.mo.nickslidejump
				and p.nick_wbcharge < nkb.WB_maxtime
					p.nick_wbcharge = $+1
					if not p.nick_premomentum
						P_SetObjectMomZ(p.mo, 5*p.mo.scale, false)
						S_StartSound(p.mo, sfx_s1bb)
						p.nick_wbdelay = 5
						p.nick_premomentum = true
					end
					if p.nick_wbcharge == nkb.WB_maxtime
						S_StartSound(p.mo, sfx_s3k41, p)
					end
				end
				if p.nick_premomentum
					p.mo.momz = $ - P_GetMobjGravity(p.mo) / 5
					if FixedHypot(p.mo.momx, p.mo.momy) >= 3*p.mo.scale
						P_Thrust(p.mo, R_PointToAngle2(p.mo.x+p.mo.momx, p.mo.y+p.mo.momy, p.mo.x, p.mo.y), p.mo.scale-p.mo.scale/3)
					end
				end
				
				if not (cmd.buttons & BT_SPIN) and (p.nick_wbcharge and p.nick_wbcharge > 0) and not p.nick_wbdelay
					local tdivider = nkb.WB_thrustdivider
					local wb_bluespeed = (tdivider and nk.WB_low_speed/tdivider) or nk.WB_low_speed
					local wb_orangespeed = (tdivider and nk.WB_medium_speed/tdivider) or nk.WB_medium_speed
					local wb_redspeed = (tdivider and nk.WB_high_speed/tdivider) or nk.WB_high_speed
					local wb_purplespeed = (tdivider and (NICK_THRUSTCAP)/tdivider) or NICK_THRUSTCAP
					
					--Blue, the weakest
					if p.nick_wbcharge <= nkb.WB_steps
						nk.Thrust(p, wb_bluespeed, wb_bluespeed)
						p.nick_wblevel = 1
					--Yellow, weak but enough
					elseif p.nick_wbcharge > nkb.WB_steps and p.nick_wbcharge <= nkb.WB_steps*2
						nk.Thrust(p, wb_orangespeed, wb_orangespeed)
						p.nick_wblevel = 2
					--Red, stronger
					elseif p.nick_wbcharge > nkb.WB_steps*2 and p.nick_wbcharge <= nkb.WB_steps*3
						nk.Thrust(p, wb_redspeed, wb_redspeed)
						p.nick_wblevel = 3
					--Purple, strongest
					elseif p.nick_wbcharge > nkb.WB_steps*3
						nk.Thrust(p, wb_purplespeed, wb_purplespeed)
						S_StartSound(p.mo, P_RandomRange(sfx_nkvc1, sfx_nkvc2))
						S_StartSound(p.mo, sfx_brakrl)
						p.nick_wblevel = 4
					end
					BM_DoWolfBuster(p)
					p.nick_wbcharge = 0
					p.nick_premomentum = false
				end
			end
			end
		end
	end
	addHook("PlayerThink", BATTLE)
	
	--ugufhgfiuhr87e
	addHook("AbilitySpecial",function(p)
		local me = p.mo
		if not (me and me.valid) then return end
		
		if me.skin ~= "nick" then return end
		if p.charability ~= CA_NICK_NUHOMING then return end
		
		print("nu homing")
	end)
	
	local function BattleHUD(v, p)
		if not (CBW_Battle or (p and p.mo and p.mo.valid)) return end
		--wolf buster charge
		if p.nick_wbcharge
			local bar = {
				x = 118,
				y = 177,
				w = 84,
				h = 8,
				padding = 2,
				flags = V_SNAPTOBOTTOM
			}
			local barfill = {
				x = bar.x + bar.padding,
				y = bar.y + bar.padding,
				w = bar.w - (bar.padding*2),
				h = bar.h - (bar.padding*2)
			}
			v.drawFill(bar.x, bar.y, bar.w, bar.h, 31|bar.flags|V_HUDTRANSHALF)
			if p.nick_wbcharge != nkb.WB_maxtime
				v.drawFill(barfill.x, barfill.y, barfill.w/3, barfill.h, 135|bar.flags)
				v.drawFill(barfill.x+(barfill.w/3), barfill.y, (barfill.w/3)+1, barfill.h, 65|bar.flags)
				v.drawFill(barfill.x+((barfill.w/3)*2), barfill.y, (barfill.w/3)+2, barfill.h, 35|bar.flags)
			else
				v.drawFill(barfill.x, barfill.y, barfill.w, barfill.h, 164|bar.flags)
			end
			
			local lockon = {
				x = barfill.x+FixedMul(FixedDiv(p.nick_wbcharge, nkb.WB_maxtime), barfill.w),
				y = barfill.y,
				sprite = v.getSpritePatch(SPR_LCKN, A, 0)
			}
			v.drawScaled(lockon.x*FU, lockon.y*FU, FU/2, lockon.sprite, bar.flags)
		end
	end
	
	addHook("HUD", BattleHUD)
	
	addHook("PlayerCanDamage", function(p)
		if not CBW_Battle return end
		if (p.mo.skin == nk.skin)
			if nk.StatesCheck(p.mo, S_NICK_BM_PUNCH)
				return true
			end
		end
	end)
	
	BMSet_Added = true
	print("\130Nick WolfFang Battle Mode support has been added!")
end

AddBattleSet()
addHook("AddonLoaded",AddBattleSet)