//Nick WolfFang ZE2 compatibility script by Jisk
//Extras by GLide KS

local nk = Nick

--ZE2 Addon compatibility
local nick_ze2config_loaded = false
local function TryZE2Compat()
	if not ZE2 return end
	if not nick_ze2config_loaded then
        ZE2:AddCharacterConfig(nk.skin, {
            health = 180,
			speed = "normal",
            desc1 = "Brave Nick WolfFang will destroy some zombies...",
            desc2 = "And also survive.",
			desc3 = "Strong and normal speed enough.",
        })

		local function NickSlide(mo)
			return nk.StatesCheck(mo, S_PLAY_NICKSLIDE)
		end
		
		addHook("PlayerThink", function(player)
			if player.mo and player.mo.skin == nk.skin
			and gametype == GT_ZE2
			
				local cmd = player.cmd
				local pmo = player.mo
				local skin = pmo.skin
				
				--play the ZE2 jump sound on Nick players
				if S_IdPlaying(skins[pmo.skin].soundsid[SKSJUMP])
					S_StopSoundByID(pmo, skins[pmo.skin].soundsid[SKSJUMP])
					S_StartSound(pmo, sfx_zjump)
				end
		
				if not player.soundplayed
					player.soundplayed = false
				end
				
				if nk.IsPlayerOnGround(player.mo) and player.ze2.crouching then
					if player.speed == 0
						player.mo.state = S_PLAY_STND
					else
						nk.PlayerThinkSystemSlideNick(player)
						player.panim = PA_DASH
						P_SpawnSkidDust(player, 18*player.mo.scale, leveltime%5 == 0 and sfx_s3k7e or nil)
					end
					player.mo.nickslidecheck = true
				else
					if pmo.state == S_PLAY_NICKSLIDE or pmo.state == S_PLAY_STND then
						if (player.speed/FU) then
							pmo.frame = A
							pmo.state = S_PLAY_WALK
						else
							pmo.frame = A
							pmo.state = S_PLAY_STND
						end
					end
				end
			end
		end)
		
		print("\130Nick WolfFang prepared for Zombie Escape 2")
        nick_ze2config_loaded = true
	end
end
TryZE2Compat()
--Add Character Config if ZE2 is loaded after Nick
addHook("AddonLoaded", TryZE2Compat)

--ZE1 Addon compatibility
local nick_ze1config_loaded = false

local function TryZE1Compat()
	if not RV_ZESCAPE return end
	if not nick_ze1config_loaded then
	
		RV_ZESCAPE.CharacterStats[nk.skin] = {
			normalspeed = 19 * FRACUNIT,
			runspeed = 100 * FRACUNIT,
			jumpfactor = 17 * FRACUNIT / 19,
			charability = CA_NONE,
			charability2 = CA2_NONE,
			startHealth = 125,
			maxHealth = 150,
			staminacost = 14,
			staminarun = 16*FRACUNIT,
			staminanormal = 24*FRACUNIT,
		}
		
		freeslot("sfx_nkzjmp")
		addHook("PlayerThink", function(player)
			if player.mo and player.mo.skin == nk.skin
			and gametype == GT_ZESCAPE
				local cmd = player.cmd
				local pmo = player.mo
				local skin = pmo.skin
				--play the ZE1 jump sound on Nick players
				if S_IdPlaying(skins[pmo.skin].soundsid[SKSJUMP])
					S_StopSoundByID(pmo, skins[pmo.skin].soundsid[SKSJUMP])
					S_StartSound(pmo, sfx_nkzjmp)
				end
			end
		end)
		
		print("\130Nick WolfFang prepared for Zombie Escape 1")
        nick_ze1config_loaded = true
	end
end
TryZE1Compat()
--Add Character Config if ZE1 is loaded after Nick
addHook("AddonLoaded", TryZE1Compat)
