--"Custom VFX for Nick" - GLide KS
//Rewritten by Mr.FondusBroMan

local nk = Nick

--Explosion
freeslot("MT_NKEXPLD", "SPR_NICK_EXPLOSION", "S_NKEXPLODE")

states[S_NKEXPLODE] = {SPR_NICK_EXPLOSION, FF_FULLBRIGHT|FF_ANIMATE|A, 8, nil, 3, 2, S_NULL}
mobjinfo[MT_NKEXPLD] = {
        doomednum = -1,
        spawnstate = S_NKEXPLODE,
		spawnhealth = 1,
        speed = 0,
        radius = 1*FRACUNIT,
        height = 1*FRACUNIT,
        mass = 1,
		flags = MF_NOGRAVITY|MF_NOCLIP|MF_FLOAT|MF_NOCLIPHEIGHT
}

-----------------Wolf Buster----------------
freeslot("MT_NICKBOOST", "S_NICKBOOST", "SPR_NICK_WOLFBUSTER")

states[S_NICKBOOST] = {SPR_NICK_WOLFBUSTER, FF_FULLBRIGHT|FF_ADD|FF_ANIMATE|A, -1, nil, 2, 2, S_NICKBOOST}

mobjinfo[MT_NICKBOOST] = {
        doomednum = -1,
        spawnstate = S_NICKBOOST,
		spawnhealth = 100,
        speed = 0,
        radius = 50*FRACUNIT,
        height = 50*FRACUNIT,
        mass = 1,
		flags = MF_NOGRAVITY|MF_NOCLIP|MF_FLOAT|MF_NOCLIPHEIGHT
}

local function NickPunch(mo)
	if not (mo and mo.valid) return end
	return mo.state == S_PLAY_CLING
end

--WB VFX Spawning and other animations
local WB_and_other_anims = function(p)
    if p.mo and p.mo.valid
        if p.mo.skin == nk.skin
			if nk.gamemodes() return end
			local speed = FixedHypot(p.mo.player.rmomx, p.mo.player.rmomy)
            if NickPunch(p.mo)
				p.drawangle = p.mo.angle
				nk.SpawnVFX(p, MT_NICKBOOST, p.mo.scale*3/2)
				if ((player == displayplayer) and not camera.chase)
				and nick_boostfx and nick_boostfx.valid
					nick_boostfx.flags2 = $|MF2_DONTDRAW
				end
                p.tracer = nick_boostfx
				
				if not (p.gotflag or p.gotcrystal)
					if not (p.powers[pw_shield] & SH_NOSTACK == SH_WHIRLWIND)
						p.mo.momz = P_MobjFlip(p.mo)<0 and min($,p.mo.scale*16) or max($,-p.mo.scale*16)
					else
						p.mo.momz = P_MobjFlip(p.mo)<0 and min($,p.mo.scale*10) or max($,-p.mo.scale*10)
					end
				end
            end
            if speed >= 50*p.mo.scale
			and P_IsObjectOnGround(p.mo)
			and (p.cmd.forwardmove or p.cmd.sidemove)
				P_SpawnSkidDust(p, 34*p.mo.scale, sfx_none)
				P_SpawnSkidDust(p, 18*p.mo.scale, sfx_none)
            end
			local mo = p.mo
			if mo.state == S_PLAY_RUN and speed >= FixedMul(50*FU, mo.scale)
				if mo.state != S_PLAY_DASH
					mo.state = S_PLAY_DASH
				end
			elseif mo.state == S_PLAY_DASH and speed < FixedMul(50*FU, mo.scale)
				if mo.state != S_PLAY_RUN
					mo.state = S_PLAY_RUN
				end
			end
		end
    end
end
addHook("PlayerThink", WB_and_other_anims)

--Wolf Buster VFX

local WolfBusterVFX = function(mo)
	if nk.gamemodes() return end
	
	local target = mo.target
    if not (mo and mo.valid) then
        return
    end

    if not (mo.target
    and mo.target.valid
    and mo.target.player)
	or target.player.mo.state != S_PLAY_CLING then
        P_RemoveMobj(mo)
        return
    end
	
	local low_speed = nk.WB_low_speed*target.scale
	local medium_speed = nk.WB_medium_speed*target.scale
	local high_speed = nk.WB_high_speed*target.scale

    local x, y = cos(mo.target.player.drawangle),sin(mo.target.player.drawangle)

    P_MoveOrigin(mo, mo.target.x+5+x, mo.target.y+5+y, mo.target.z)
	mo.angle = mo.target.player.drawangle
	local boostghost = P_SpawnGhostMobj(mo)
	P_MoveOrigin(boostghost,mo.x,mo.y,mo.z)
	boostghost.fuse = 4
	boostghost.dispoffset = 50
	
	local p = target.player
	local speed = FixedHypot(p.rmomx, p.rmomy)
	
	if not G_GametypeHasTeams()
		if not (p.powers[pw_shield] & SH_NOSTACK == SH_WHIRLWIND)
			if not p.nick_powerscolor
				if not CBW_Battle
					if speed <= low_speed and mo.color != SKINCOLOR_CERULEAN --Low speed color
						mo.color = SKINCOLOR_CERULEAN
					elseif (speed >= low_speed and speed < medium_speed) and mo.color != SKINCOLOR_ORANGE --Medium Speed Color
						mo.color = SKINCOLOR_ORANGE
					elseif (speed >= medium_speed and speed < high_speed) and mo.color != SKINCOLOR_RED --High Speed Color
						mo.color = SKINCOLOR_RED
					elseif speed >= high_speed and mo.color != SKINCOLOR_PURPLE --Ultra Speed Color
						mo.color = SKINCOLOR_PURPLE
					end
				else
					if p.nick_wblevel == 1 and mo.color != SKINCOLOR_CERULEAN
						mo.color = SKINCOLOR_CERULEAN
					elseif p.nick_wblevel == 2 and mo.color != SKINCOLOR_ORANGE
						mo.color = SKINCOLOR_ORANGE
					elseif p.nick_wblevel == 3 and mo.color != SKINCOLOR_RED
						mo.color = SKINCOLOR_RED
					elseif p.nick_wblevel == 4 and mo.color != SKINCOLOR_PURPLE
						mo.color = SKINCOLOR_PURPLE
					end
				end
			elseif mo.color != p.nick_powerscolor
				mo.color = p.nick_powerscolor
			end
		elseif mo.color != SKINCOLOR_CARBON
			mo.color = SKINCOLOR_CARBON
		end
	elseif mo.color != p.mo.color
		mo.color = p.mo.color
	end
	
	--Speed animation handling
	if (speed >= medium_speed and not CBW_Battle) 
	or (p.nick_wblevel and p.nick_wblevel >= 3 and CBW_Battle)
		mo.anim_duration = 1
	end
		
	if ((speed >= high_speed and not CBW_Battle) or (p.nick_wblevel and p.nick_wblevel == 4 and CBW_Battle))
	and not (p.gotflag or p.gotcrystal)
		nk.GhostShape(target, mo.color)
	end
	if p.gotflag or p.gotcrystal
		mo.alpha = FU/3
	else
		mo.alpha = FU
	end
	nk.FlipChecks(mo, -8*FU)
end
addHook("MobjThinker", WolfBusterVFX, MT_NICKBOOST)

-----------------Sprint VFX----------------
freeslot("S_WOOSH_NICK", "SPR_NICK_WOOSH","MT_WOOSH_FOLLOW")

states[S_WOOSH_NICK] = {SPR_NICK_WOOSH, FF_ANIMATE|A, -1, nil, 4, 2, S_WOOSH_NICK}
mobjinfo[MT_WOOSH_FOLLOW] = {
    radius = 1,
    height = 1,
    spawnstate = S_WOOSH_NICK,
	flags = MF_NOCLIP|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

addHook("MobjSpawn", function(mo)
    mo.offset = 7
end, MT_WOOSH_FOLLOW)

local WooshFollow = function(mo)
	if nk.gamemodes() return end
	
    if not (mo and mo.valid) then
        return
    end

    if not (mo.target
    and mo.target.valid
    and mo.target.player) then
        P_RemoveMobj(mo)
        return
    end

    local x, y = cos(mo.target.player.drawangle),sin(mo.target.player.drawangle)

    P_MoveOrigin(mo, mo.target.x+(mo.offset*x), mo.target.y+(mo.offset*y), mo.target.z)
	mo.angle = mo.target.player.drawangle
	nk.FlipChecks(mo, 76*FU)
end
addHook("MobjThinker", WooshFollow, MT_WOOSH_FOLLOW)

-----------------Strong Slide VFX----------------

freeslot("S_WOOSHSLD_NICK", "SPR_NICK_SLDWOOSH","MT_WOOSHSLD_FOLLOW")
states[S_WOOSHSLD_NICK] = {SPR_NICK_SLDWOOSH, FF_ANIMATE|A, -1, nil, 4, 1, S_WOOSHSLD_NICK}

mobjinfo[MT_WOOSHSLD_FOLLOW] = {
    radius = 1,
    height = 1,
    spawnstate = S_WOOSHSLD_NICK,
	flags = MF_NOCLIP|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

addHook("MobjSpawn", function(mo)
    mo.offset = 7
end, MT_WOOSHSLD_FOLLOW)

addHook("MobjSpawn", function(mo)
    mo.offset = 0
end, MT_NICKBOOST)

local WooshSld = function(mo)
	if nk.gamemodes() return end

    if not (mo and mo.valid) then
        return
    end

    if not (mo.target
    and mo.target.valid
    and mo.target.player) then
        P_RemoveMobj(mo)
        return
    end
	
	if not (mo.target
    and mo.target.valid
    and mo.target.player)
	or mo.target.player.speed <= nk.Slide_strongspeed*mo.target.player.mo.scale then
        P_RemoveMobj(mo)
        return
    end

    local x, y = cos(mo.target.player.drawangle),sin(mo.target.player.drawangle)

    P_MoveOrigin(mo, mo.target.x+(mo.offset*x), mo.target.y+(mo.offset*y), mo.target.z)
	mo.angle = mo.target.player.drawangle
	nk.FlipChecks(mo, 34*FU)
end
addHook("MobjThinker", WooshSld, MT_WOOSHSLD_FOLLOW)

--Hover Wheel Bike Glow

freeslot("SPR_NKJETSKI_WHEELLIGHT", "MT_NKJETSKI_WHEEL", "S_NKJETSKI_WHEEL01",
		 "S_NKJETSKI_WHEEL02", "S_NKJETSKI_WHEEL03", "S_NKJETSKI_WHEEL04",
		 "S_NKJETSKI_WHEEL05","S_NKJETSKI_WHEEL06","S_NKJETSKI_WHEEL07",
		 "S_NKJETSKI_WHEEL08")

states[S_NKJETSKI_WHEEL01] = {SPR_NKJETSKI_WHEELLIGHT, FF_FULLBRIGHT|FF_ADD|4, 4, nil, 0, 0, S_NKJETSKI_WHEEL02}
states[S_NKJETSKI_WHEEL02] = {SPR_NKJETSKI_WHEELLIGHT, FF_FULLBRIGHT|FF_ADD|3, 2, nil, 0, 0, S_NKJETSKI_WHEEL03}
states[S_NKJETSKI_WHEEL03] = {SPR_NKJETSKI_WHEELLIGHT, FF_FULLBRIGHT|FF_ADD|2, 2, nil, 0, 0, S_NKJETSKI_WHEEL04}
states[S_NKJETSKI_WHEEL04] = {SPR_NKJETSKI_WHEELLIGHT, FF_FULLBRIGHT|FF_ADD|1, 2, nil, 0, 0, S_NKJETSKI_WHEEL05}
states[S_NKJETSKI_WHEEL05] = {SPR_NKJETSKI_WHEELLIGHT, FF_FULLBRIGHT|FF_ADD|0, TICRATE/2, nil, 0, 0, S_NKJETSKI_WHEEL06}
states[S_NKJETSKI_WHEEL06] = {SPR_NKJETSKI_WHEELLIGHT, FF_FULLBRIGHT|FF_ADD|1, 2, nil, 0, 0, S_NKJETSKI_WHEEL07}
states[S_NKJETSKI_WHEEL07] = {SPR_NKJETSKI_WHEELLIGHT, FF_FULLBRIGHT|FF_ADD|2, 2, nil, 0, 0, S_NKJETSKI_WHEEL08}
states[S_NKJETSKI_WHEEL08] = {SPR_NKJETSKI_WHEELLIGHT, FF_FULLBRIGHT|FF_ADD|3, 2, nil, 0, 0, S_NKJETSKI_WHEEL01}

mobjinfo[MT_NKJETSKI_WHEEL] = {
	doomednum = -1,
	spawnstate = S_NKJETSKI_WHEEL01,
	spawnhealth = 100,
	speed = 0,
    radius = 1*FRACUNIT,
    height = 30*FRACUNIT,
    mass = 1,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_FLOAT|MF_NOCLIPHEIGHT
}

local Wheel = function(mo)

	local target = mo.target
	if not (mo and mo.valid) then
		return
	end

	if not (mo.target
	and mo.target.valid
	and mo.target.player)
	or not mo.target.boat
		P_RemoveMobj(mo)
		return
	end

	P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	local p = target.player
	mo.angle = p.mo.angle
	mo.spriteroll = p.mo.spriteroll
	mo.scale = p.mo.scale
	
	if not G_GametypeHasTeams()
		if not (mo.target.player.powers[pw_shield] & SH_NOSTACK == SH_WHIRLWIND)
			if not p.nick_powerscolor
				if mo.color != SKINCOLOR_GALAXY
					mo.color = SKINCOLOR_GALAXY
				end
			elseif mo.color != p.nick_powerscolor
				mo.color = p.nick_powerscolor
			end
		end
	elseif mo.color != p.mo.color
		mo.color = p.mo.color
	end
	
	mo.dispoffset = 100
	nk.FlipChecks(mo, 39*FU)
end

addHook("MobjThinker", Wheel, MT_NKJETSKI_WHEEL)