//Rewritten by Mr.FondusBroMan
//General and actual maintainer: GLide KS
local nk = Nick

--Setting these states as damage
local NickDamage = function(mo)
	return 
	nk.StatesCheck(mo, S_PLAY_CLIMB) or
	nk.StatesCheck(mo, S_PLAY_GLIDE)
end
local NickDamage2 = function(mo)
	return nk.StatesCheck(mo, S_PLAY_CLIMB)
end
local NickPoses = function(mo)
	return 
	nk.StatesCheck(mo, S_NICK_STANCE01, S_NICK_STANCE09) or
	nk.StatesCheck(mo, S_PLAY_NICK_WAIT01, S_PLAY_NICK_WAIT06) or
	nk.StatesCheck(mo, S_NICKBRUH) or
	nk.StatesCheck(mo, S_NICKSIT) or
	nk.StatesCheck(mo, S_NICK_DRIP) or
	nk.StatesCheck(mo, S_NICK_FINO)
end
local NickPunchDamage = function(mo)
	return nk.StatesCheck(mo, S_PLAY_CLING)
end
local NickDash = function(mo)
	return nk.StatesCheck(mo, S_PLAY_GLIDE)
end
local NickSlide = function(mo)
	return nk.StatesCheck(mo, S_PLAY_NICKSLIDE)
end
local NickSlideJump = function(mo)
	if nk.StatesCheck(mo, S_PLAY_ROLL)
	and mo.nickslidejump
		return true
	end
end

--Slide System
nk.PlayerThinkSystemSlideNick = function(p) 
	if not (p and p.valid and p.mo and p.mo.valid) return end
	if NickSlide(p.mo) return end
	if not p.mo.nickdash
		p.mo.nickslidetime = 3
		p.mo.state = S_PLAY_NICKSLIDE
	end
end

local DamageFunc

--addHook("PlayerCanDamage", function(p)
local DamageFunc = function(p)
if (p.mo.skin == nk.skin)
	if NickDamage(p.mo) and not CBW_Battle
		return true
	elseif NickDamage2(p.mo) and CBW_Battle
		return true
	end
	if NickPunchDamage(p.mo) 
	or NickSlide(p.mo) 
	or NickSlideJump(p.mo)
		return true
	end
end
end
addHook("PlayerCanDamage", DamageFunc)

-- Which strong effects will have Nick when obtained?
local STR_NICK = STR_SPRING|STR_SPIKE|STR_BUST|STR_ANIM
--Second one for Spin kick. only removing spring powerup and spikes
local STR_NICK2 = STR_BUST|STR_ANIM 

---Swipe kick homing handler---
local HomingDamage = function(damagemobj, mo)
if NickDamage2(mo) and damagemobj.valid
	mo.nick_homingcheck = true
end
end

addHook("MobjDamage", function(damagemobj, mo)
	if damagemobj.valid
		return HomingDamage(damagemobj, mo)
	end
end)

addHook("MobjDeath", function(damagemobj, mo)
	if damagemobj.valid and damagemobj.flags & MF_MONITOR
		return HomingDamage(damagemobj, mo)
	end
end)

/*-----------------------DOUBLE JUMP/SWIPEKICK--------------------------*/
local CustomDoubleJump = function(p)
if p and p.mo and p.mo.skin == nk.skin
--Exclude abilities from Saxa's Murder Mystery
and not nk.gamemodes()
	if p.charability == 66
	and (p.playerstate != PST_DEAD)
		if not (nk.IsPlayerOnGround(p.mo))
			if (p.pflags & PF_JUMPED)
				if not (p.nick_bouncedid or p.mo.state == S_PLAY_CLING)
					if not NICK_RESTRICT_HOMING
						if p.enemytarget and p.enemytarget.valid
						and p.enemydistance <= NICK_HOMINGDISTANCE 
						and p.enemydistance2 <= NICK_HOMINGDISTANCE
						and not p.nick_homingcd
						and not (p.nick_wbcharge)
							if not p.kickdid
							and not NickSlide(mo)
							and not p.actionstate
							and not (p.gotflag or p.gotcrystal)
								if CBW_Battle
									nk.HomingKick(p.mo, p.enemytarget, nk.battle.homingspeed*p.mo.scale)
								end
								S_StartSound(p.mo, sfx_spnkck)
								p.mo.state = S_PLAY_CLIMB
								p.pflags = $&~(PF_THOKKED)
								
								if p.enemytarget
									p.mo.tracer = p.enemytarget
									p.mo.target = p.mo.tracer
								end
								p.kick_timer = CBW_Battle and 2 or 20
								if (CBW_Battle)
									p.homing = 2
								end
								p.kickdid = true
							end
						end
					end
				else
					if not p.jumpdid
					and not NICK_RESTRICT_DOUBLEJUMP
					and not (p.gotflag or p.gotcrystal)
					and not (CBW_Battle)
						--The 2nd Jump
						p.pflags = $ & ~(PF_JUMPED|PF_SPINNING)
						p.pflags = $ & ~PF_NOJUMPDAMAGE
						p.mo.state = S_PLAY_NICKDOUBLEJUMP
						S_StartSound(p.mo, sfx_nckdjp)
					
						for i = 1, 12
							local dust = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
							dust.angle = ANG30*i
							dust.flags = $|MF_SCENERY
							dust.frame = $|FF_TRANS50
							P_InstaThrust(dust, dust.angle, 16*dust.scale)
							P_Thrust(dust, p.mo.angle, p.speed/2)
						end
						P_DoJump(p, false)
						p.pflags = $|PF_JUMPED|PF_THOKKED
						p.kickdid = false
						p.nick_bouncedid = false
						p.jumpdid = true
					end
				end
			end
		end
	end
end
end

local KickChecks = function(p)
	if p.kickdid 
		if nk.IsPlayerOnGround(p.mo)
		or p.chaintimer
		and p.mo.state == S_NICKKICK_OFFHOMING
			p.kickdid = false
		end
	end
	if p.chaintimer
		p.chaintimer = $-1
	end
	if p.nick_homingcd == nil
		p.nick_homingcd = 0
	elseif p.nick_homingcd
		p.nick_homingcd = $-1
	end
	if p.enemytarget and p.enemytarget.valid
	and p.kickdid
	and NickDamage(p.mo)
	and not CBW_Battle
		P_HomingAttack(p.mo, p.enemytarget)
	end
	-- stop homing to springs ffs
	if NickDamage(p.mo)
	and not p.mo.nick_homingcheck
		if (p.mo.eflags & MFE_SPRUNG)
			if p.mo.momz > 0
				p.mo.state = S_PLAY_SPRING
			else
				p.mo.state = S_PLAY_FALL
			end
		end
	end
	if (p.mo.eflags & MFE_SPRUNG)
	and (p.pflags & PF_JUMPED)
		p.kickdid = false
		p.jumpdid = false
		p.punch_used = false
		p.nick_bouncedid = false
	end
end

local StatesProperties = function(mo)
	if mo.state == S_PLAY_CLIMB
		if mo.tics > 1
			mo.tics = 2
		end
	end
end

local asustado_requirement = function(p)
	--In general, if you have lower health/rings or other stuff that might be in danger for Nick
	--will switch to a nick scared version of "fino" emote.
	if not nk.gamemodes() and not p.rings -- rings
	-- hp based gamemodes
	or (nk.gamemodes() and (PSO and p.pso.hp <= p.pso.maxhp/3))
	or (nk.gamemodes() and (ZE2 and p.mo.health <= p.mo.maxhealth/3))
	or (nk.gamemodes() and (RV_ZESCAPE and p.mo.health <= p.mo.maxHealth/3))
		return true
	end
end

/*------------------------------Main Script---------------------------*/
local Main = function(p)
	if not (p and p.valid and p.mo and p.mo.valid) return end
	local mo = p.mo
	local cmd = p.cmd
	if mo.skin == nk.skin
		if p.nick_changedchar
			p.nick_changedchar = false
		end
		local speed = FixedHypot(p.mo.player.rmomx, p.mo.player.rmomy)
		KickChecks(p)

		if p.canceltimer
		and not (cmd.buttons & BT_SPIN)
			p.canceltimer = $-1
		end
		if not p.chaintimer
		and not nk.IsPlayerOnGround(mo)
		and (p.pflags & PF_JUMPED)
			if p.mo.state == S_NICKKICK_OFFHOMING
				if mo.momz > 0
					mo.state = S_PLAY_SPRING
				else
					mo.state = S_PLAY_FALL
				end
				p.kickdid = true
			end
		end
		
		StatesProperties(mo)
			
		--Jump checks
		if p.jumpdid and not (p.pflags & PF_JUMPED)
			p.jumpdid = false
		end
		--Slide checks
		local rollingcheck = mo.state == S_PLAY_ROLL and p.pflags & PF_SPINNING and not mo.nickslidejump
		if mo.nickslidecheck == nil
			mo.nickslidecheck = false
		end
		if not (mo.nickslidecheck)
		or rollingcheck
			mo.nickslidecheck = false
		end
		
		--Legacy?!
		if p.nick_legacy
			if not p.nick_legacy_ison
				mo.translation = "Nick_Legacy"
				if not ((MM and MM:isMM()) or G_GametypeHasTeams())
				and mo.color != SKINCOLOR_BROWN
					mo.color = SKINCOLOR_BROWN
				end
				p.nick_legacy_ison = p.nick_legacy
			end
			if mo.color != SKINCOLOR_BROWN and p.nick_legacy_ison
			and not ((MM and MM:isMM()) or G_GametypeHasTeams())
				mo.color = SKINCOLOR_BROWN
			end
			if not mo.translation and p.nick_legacy_ison
				mo.translation = "Nick_Legacy"
			end
		else
			if p.nick_legacy_ison
				mo.translation = nil
				if not ((MM and MM:isMM()) or G_GametypeHasTeams())
					mo.color = p.skincolor
				end
				p.nick_legacy_ison = p.nick_legacy
			end
		end
		
		--Clone Fighter!
		if not p.nick_legacy
			if p.nick_clonefighter
				if not G_GametypeHasTeams()
					if not mo.translation
						mo.translation = "Grayscale"
					end
				end
			else
				if mo.translation
					mo.translation = nil
				end
			end
		end
		
		--Jetski Support
		if mo.boat
		and not (p.nkbikewheel and p.nkbikewheel.valid)
			p.nkbikewheel = P_SpawnMobjFromMobj(mo, 0,0,0, MT_NKJETSKI_WHEEL)
			p.nkbikewheel.target = mo
			p.nkbikewheel.spriteroll = mo.spriteroll
		end
	
	if not mo.boat --block all of this when riding jetski
		--Homing kick animation handling
		if p.kick_timer
			p.kick_timer = $-1
		end
		if mo.nick_homingcheck
			p.kick_timer = 0
		end
		
		--Look for enemies to homing
		if not (p.nick_bouncedid or p.mo.state == S_PLAY_CLING)
		and (p.pflags & PF_JUMPED)
		and not nk.gamemodes()
		and not p.powers[pw_carry]
		and not nk.IsPlayerOnGround(mo)
		and not p.kickdid
		and not p.actionstate
		and not (p.gotflag or p.gotcrystal)
		and not p.nick_homingcd
		and not (CBW_Battle and CBW_Battle.BattleGametype() or p.nick_wbcharge)
			p.enemytarget = P_LookForEnemies(p, true, false)
			if p.enemytarget and p.enemytarget.valid
				p.enemydistance = R_PointToDist2(p.mo.x, p.mo.y, p.enemytarget.x, p.enemytarget.y)
				p.enemydistance2 = R_PointToDist2(p.mo.z, p.mo.z, p.enemytarget.z, p.enemytarget.z)
			end
			if not (p.powers[pw_shield] & SH_NOSTACK == SH_ATTRACT)
				local t = p.enemytarget
				if t and t.valid
					local tdist = p.enemydistance
					local tdist2 = p.enemydistance2
					if (tdist or tdist2) and (tdist <= NICK_HOMINGDISTANCE and tdist2 <= NICK_HOMINGDISTANCE)
						P_SpawnLockOn(p, t, S_LOCKON1)
					end
				end
			end
		end
		
		--Slide spin button checks
		if (cmd.buttons & BT_SPIN)
		and not ((p.lastbuttons & BT_SPIN) and not (mo.eflags & MFE_JUSTHITFLOOR or rollingcheck))
		and not nk.gamemodes()
		and not p.exiting
		and p.speed > 3*mo.scale
		and not p.powers[pw_carry]
		and not NICK_RESTRICT_SLIDE
		and not (p.pflags & PF_STASIS)
		and not mo.nickslidecheck
		and not p.actionstate
		and not srb2p
		and (P_IsObjectOnGround(mo) and not (P_CheckDeathPitCollide(mo) or p.playerstate == PST_DEAD))
			nk.PlayerThinkSystemSlideNick(p)
		end
		if mo.nickslidetime == nil
			mo.nickslidetime = 0
		end
		if mo.nickslidetime > 0
			mo.nickslidetime = $ - 1
		end
		-- Slide Cosmetics and power ups
		if mo.slidechecktimer == nil
			mo.slidechecktimer = 0
		end
		if mo.slidechecktimer > 0
			mo.slidechecktimer = $1 - 1 
		end
		if NickSlide(mo)
			mo.slidechecktimer = 3
			if speed >= nk.Slide_strongspeed*mo.scale
				if not G_GametypeHasTeams()
					if not p.nick_powerscolor
						nk.GhostShape(mo, SKINCOLOR_PURPLE)
					else
						nk.GhostShape(mo, p.nick_powerscolor)
					end
				else
					nk.GhostShape(mo, mo.color)
				end
				if nk.IsPlayerOnGround(mo)
					P_SpawnSkidDust(p, 34*mo.scale, leveltime%3 == 0 and sfx_s3k7e or nil)
				end
				nk.SpawnVFX(p, MT_WOOSHSLD_FOLLOW, mo.scale*3/2)
			end
			p.panim = PA_ROLL
			if not (p.pmomz or (p.mo.eflags & MFE_APPLYPMOMZ))
				p.panim = PA_DASH
			end
			if nk.IsPlayerOnGround(mo)
				P_SpawnSkidDust(p, 18*mo.scale, leveltime%5 == 0 and sfx_s3k7e or nil)
			end
			mo.nickslidecheck = true
			p.pflags = $|PF_SPINNING|PF_SPINDOWN --Slide has rolling effects
			mo.nickspincheck = true
			if p.speed == 0
				if (mo.eflags & MFE_JUSTHITFLOOR)
					mo.state = S_PLAY_WALK
				else
					mo.state = S_PLAY_SPRING
				end
			elseif not (cmd.buttons & BT_SPIN)
			and mo.nickslidecheck == true
				if nk.IsPlayerOnGround(mo)
					mo.state = S_PLAY_WALK
					mo.nickslidecheck = false
				end
			end
			
			if nk.stupidbouncesectors(mo,mo.subsector.sector)
			and (mo.momz ~= 0)
				mo.state = S_PLAY_ROLL
				p.pflags = $|PF_JUMPED &~(PF_THOKKED|PF_SPINNING)
			end
		else
			if mo.nickslidecheck == true
				mo.nickslidecheck = false
			end
			if mo.nickspincheck == true
				if (mo.state ~= S_PLAY_ROLL)
					p.pflags = $ & ~(PF_SPINNING)--|PF_SPINDOWN)
				end
				mo.nickspincheck = false
			end
		end
		if not NickSlide(mo) and p.nick_vfx and p.nick_vfx.valid and p.nick_vfx.type == MT_WOOSHSLD_FOLLOW
			if not (p.playerstate != PST_LIVE)
			or p.speed < 40*mo.scale
				P_RemoveMobj(p.nick_vfx)
			end
		end
		if not (mo.nickspincheck)
			mo.nickspincheck = false
		end
		
		
		
		if not nk.gamemodes()
			if not mo.dash_used
				mo.dash_used = false
			end
			if not (mo.doublejumpnickdrawangle)
				mo.doublejumpnickdrawangle = 0
			end
			if mo.state == S_PLAY_NICKDOUBLEJUMP
				mo.doublejumpnickdrawangle = $ + FixedAngle(40*FRACUNIT)
				p.drawangle = mo.doublejumpnickdrawangle
			else
				mo.doublejumpnickdrawangle = 0
			end
			if not (mo.nickdash)
				mo.nickdash = 0
			end
			if mo.nickdash > 0
				mo.nickdash = $ - 1
			end
			if NickDamage(mo)
				p.panim = PA_DASH
				if not NickDash(mo)
					nk.GhostShape(mo, mo.color)
					if (nk.IsPlayerOnGround(mo)) or (mo.eflags & MFE_JUSTHITFLOOR)
						mo.state = S_PLAY_WALK
					end
				end
			end
			if NickDamage2(mo)
			or NickSlideJump(mo)
			or NickPunchDamage(mo)
				p.powers[pw_strong] = $|STR_NICK2
			end
			if not (p.mo.nickdash_cooldown)
				p.mo.nickdash_cooldown = 0
			end
			if p.mo.nickdash_cooldown > 0
				p.mo.nickdash_cooldown = $ - 1
			end
			if p.mo.nickdash_cooldown > 0
				p.mo.dash_used = true
			end
			if NickDash(p.mo)
				p.panim = PA_DASH
    			if (mo.eflags & MFE_JUSTHITFLOOR)
					mo.momx = $/2
					mo.momy = $/2
					P_SpawnSkidDust(p, 13*FRACUNIT, sfx_s3k7e)
					mo.nickdash_cooldown = 3
					mo.state = S_PLAY_WALK
				end
			end
			if (nk.IsPlayerOnGround(mo)) or (mo.eflags & MFE_JUSTHITFLOOR)
			and mo.dash_used
			and not (cmd.buttons & BT_SPIN)
				mo.dash_used = false
			end
		end
		
		if mo.nick_homingcheck
			P_SetObjectMomZ(mo, 8*FU, false)
			if cmd.forwardmove
			or cmd.sidemove
				if CBW_Battle
					p.nick_homingcd = nk.battle.homingcdtimer
				end
				if not p.powers[pw_sneakers]
					mo.momx = $/2
					mo.momy = $/2
				end
			else
				if not CBW_Battle
					mo.momx = 0
					mo.momy = 0
				else
					mo.momx = $/2
					mo.momy = $/2
				end
			end
			p.homingtimer = 0
			p.chaintimer = 1*TICRATE
			if p.chaintimer
				mo.state = S_NICKKICK_OFFHOMING
			end
			if (consoleplayer == p)
				P_StartQuake(8*mo.scale, TICRATE/5, {mo.x, mo.y, mo.z})
			end
			S_StartSound(mo, sfx_bedeen)
			mo.nick_homingcheck = false
		end
		
		--Custom wait animations activation
		if mo.state == S_PLAY_STND
		and mo.tics == 1
			mo.state = S_PLAY_NICK_WAIT01
		end
		
		if mo.state >= S_PLAY_NICK_WAIT01 and mo.state <= S_PLAY_NICK_WAIT06
			if cmd.forwardmove or cmd.sidemove
				mo.state = S_PLAY_WALK
			end
		end

		--Custom 2 - Shield Ability
		if p.powers[pw_carry] == CR_NONE
			--spawn attraction target
			if (p.powers[pw_shield] & SH_NOSTACK == SH_ATTRACT)
				local t = P_LookForEnemies(p,false,false)
				if t and t.valid
				and not (mo.state >= 59 and mo.state <= 64)
					P_SpawnLockOn(p, t, S_LOCKON2)
				end
			end
		end
		
		if not (p.mo.nickshieldwork)
			p.mo.nickshieldwork = false
		end
		if not (p.mo.nick2button)
			p.mo.nick2button = false
		elseif not (cmd.buttons & BT_CUSTOM2)
			p.mo.nick2button = false
		elseif (nk.IsPlayerOnGround(mo))
			p.mo.nick2button = true
		end
		if (nk.IsPlayerOnGround(mo))
			p.charflags = $|SF_NOSHIELDABILITY
			p.mo.nickshieldwork = false
		else
			if p.mo.nick2button == true
				p.mo.nickshieldwork = true
			end
		end
		if (cmd.buttons & BT_CUSTOM2)
		and not p.exiting
		and not p.powers[pw_carry]
		and not (p.pflags & PF_STASIS)
		and not (p.mo.tracer and p.mo.tracer.type == MT_TUBEWAYPOINT)
		and not srb2p -- check about Srb2 Persona
		and not (nk.IsPlayerOnGround(p.mo))
		and not (CBW_Battle) --Check about Battle mod
		and (p.pflags & PF_JUMPED)
		and not (p.pflags & PF_SHIELDABILITY)
		and not p.mo.nick2button
			local checkshields = SH_NOSTACK
			if (p.powers[pw_shield] & checkshields == SH_ARMAGEDDON)
				A_OldRingExplode(p.mo, MT_SONIC3KBOSSEXPLODE)
				P_BlackOw(p)
				P_StartQuake(20*FRACUNIT, 35, {mo.x, mo.y, mo.z}, p.mo.radius)
				P_Earthquake(p.mo, p.mo, 256*FRACUNIT)
				P_StartQuake(79*FRACUNIT, 3)
				P_FlashPal(p, PAL_WHITE, 3)
				S_StartSound(p.mo, sfx_bkpoof)
				P_NukeEnemies(p.mo, p.mo, RING_DIST)
			elseif (p.powers[pw_shield] & checkshields == SH_WHIRLWIND)
				P_DoJumpShield(p)
				p.pflags = ($|PF_THOKKED)
			elseif (p.powers[pw_shield] & checkshields == SH_ELEMENTAL)
				mo.state = S_PLAY_ROLL
				mo.momx = $ * 3/5
				mo.momy = $ * 3/5
				P_SetObjectMomZ(mo, -25*FRACUNIT)
				S_StartSound(mo,sfx_s3k43)
				p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY)
			elseif (p.powers[pw_shield] & checkshields == SH_ATTRACT)
				local lockonshield = P_LookForEnemies(p, false, false)
				mo.tracer = lockonshield
				mo.target = lockonshield
				if lockonshield and lockonshield.valid
					p.pflags = ($|PF_THOKKED|PF_JUMPED|PF_SHIELDABILITY) & ~(PF_NOJUMPDAMAGE)
					mo.state = S_PLAY_ROLL
					mo.angle = R_PointToAngle2(mo.x, mo.y, lockonshield.x, lockonshield.y)
					S_StartSound(mo, sfx_s3k40)
					p.homing = 1*TICRATE/2
				else
					p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY)
					S_StartSound(mo, sfx_s3ka6)
					p.homing = 2
				end
			elseif (p.powers[pw_shield] & SH_FORCE)
			and not (p.nick_forceused)
				P_InstaThrust(mo, 0, 0*FRACUNIT)
				P_SetObjectMomZ(mo, 0)
				S_StartSound(mo,sfx_ngskid)
				p.pflags = $|PF_THOKKED|PF_SHIELDABILITY
				p.weapondelay = 25
				p.nick_forceused = true
			elseif (p.powers[pw_shield] & checkshields == SH_BUBBLEWRAP)
				mo.momx = $/3
				mo.momy = $/3
				S_StartSound(mo,sfx_s3k44)
				mo.state = S_PLAY_ROLL
				p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY) & ~PF_NOJUMPDAMAGE
				P_SetObjectMomZ(mo, -24*FRACUNIT)
			elseif (p.powers[pw_shield] & checkshields == SH_THUNDERCOIN)
				mo.state = S_PLAY_ROLL
				P_DoJumpShield(p)
				S_StartSound(mo,sfx_s3k45)
				p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY) & ~PF_NOJUMPDAMAGE
			elseif (p.powers[pw_shield] & checkshields == SH_FLAMEAURA)
				mo.state = S_PLAY_ROLL
				P_Thrust(mo, mo.angle, 30*mo.scale)
				S_StartSound(mo,sfx_s3k43)
				p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY) & ~PF_NOJUMPDAMAGE
			end
			p.mo.nick2button = true
			if not p.nick_forceused
				p.pflags = $1|PF_SHIELDABILITY
			end
		end
		--Woosh effect on sprint
		if NickDash(mo)
			nk.SpawnVFX(p, MT_WOOSH_FOLLOW, mo.scale)
		end
				
		if p.nick_vfx and p.nick_vfx.valid and p.nick_vfx.type == MT_WOOSH_FOLLOW
			if not NickDash(mo)
			or (p.playerstate != PST_LIVE)
				P_RemoveMobj(p.nick_vfx)
			end
			if (p == displayplayer) 
			or (p == secondarydisplayplayer) 
				if not camera.chase
					if p.nick_vfx.valid
					and not (p.nick_vfx.flags2 & MF2_DONTDRAW)
						p.nick_vfx.flags2 = $|MF2_DONTDRAW
					end
				else
					if p.nick_vfx and p.nick_vfx.valid
					and (p.nick_vfx.flags2 & MF2_DONTDRAW)
						p.nick_vfx.flags2 = $ & ~MF2_DONTDRAW
					end
				end
			end
		end

		--Take a sit in the cart! don't stand only.
		if p.powers[pw_carry] == CR_MINECART
		and (p.playerstate == PST_LIVE)
			mo.state = S_PLAY_GLIDE_LANDING
		end
		
		--Jump roll in MM
		--to pair up with most characters that takes rolling jump as a must have to dodge
		--and because nick's hitbox is big (easy target for sheriffs)
		if (MM and gametype == (GT_LTMMURDERMYSTERY or GT_SAXAMM))
			if (p.charflags & SF_NOJUMPSPIN)
				p.charflags = $ &~SF_NOJUMPSPIN
			end
		else
			if not (p.charflags & SF_NOJUMPSPIN)
				p.charflags = $|SF_NOJUMPSPIN
			end
		end
		
		--Looking System, only exclusive for STND
		if p.nick_looking
			if mo.state == S_PLAY_STND
				if not mo.ticschanged
					mo.tics = -1
					mo.ticschanged = true
				end
				if p.aiming >= ANGLE_45/3
					if P_MobjFlip(mo) == 1
						mo.sprite2 = SPR2_MLEL
					else
						mo.sprite2 = SPR2_TWIN
					end
				elseif p.aiming < ANGLE_45/3 and p.aiming > -ANGLE_45/3
					mo.sprite2 = SPR2_STND
				elseif p.aiming <= -ANGLE_45/4
					if P_MobjFlip(mo) == 1
						mo.sprite2 = SPR2_TWIN
					else
						mo.sprite2 = SPR2_MLEL
					end
				end
			else
				if mo.state == S_PLAY_WAIT
				or nk.StatesCheck(mo, S_PLAY_NICK_WAIT01, S_PLAY_NICK_WAIT06)
					mo.state = S_PLAY_STND
				end
				if mo.ticschanged
					mo.ticschanged = false
				end
			end
		elseif mo.state == S_PLAY_STND
			if mo.sprite2 == SPR2_TWIN
			or mo.sprite2 == SPR2_MLEL
				mo.state = S_PLAY_STND
			end
		end
		
		--Knockback hurt
		if not p.nightstime
			local knkback_activate = FixedMul(p.mo.scale, NICK_KNOCKBACKACTIVATION)
			if P_PlayerInPain(p)
				if (p.speed >= knkback_activate or mo.momz >= knkback_activate)
				and mo.state == (S_PLAY_PAIN)
				and mo.health
				and not p.nick_gotknockback
					S_StartSound(mo, sfx_nickh1)
					if mo.sprite2 == SPR2_PAIN
						mo.sprite2 = SPR2_TIRE
					end
					p.nick_gotknockback = true
				end
			elseif p.nick_gotknockback
				p.nick_gotknockback = false
			end
		
			if mo.state == S_PLAY_PAIN
			and mo.sprite2 == SPR2_TIRE
				mo.spriteroll = $-(ANG15+FixedAngle(FixedDiv(p.speed, p.mo.scale)))
			elseif mo.spriteroll
				mo.spriteroll = 0
			end
		end
		--Slide Jump
		if mo.slidechecktimer > 0
			if (cmd.buttons & BT_SPIN) and (p.pflags & PF_JUMPED)
			and not mo.nickslidejump
				mo.state = S_PLAY_ROLL
				mo.nickslidejump = 1
			end
		end
		if mo.nickslidejump == 1 and (p.mo.eflags & MFE_JUSTHITFLOOR)
			mo.nickslidejump = 0
		end
		if NickSlideJump(mo) and mo.nickslidejump
		and not p.powers[pw_carry]
			if not G_GametypeHasTeams()
				if not p.nick_powerscolor
					nk.GhostShape(mo, SKINCOLOR_PURPLE)
				else
					nk.GhostShape(mo, p.nick_powerscolor)
				end
			else
				nk.GhostShape(mo, mo.color)
			end
		end
		
/*-----------------Emotes!--------------*/
		if p.nickemoted == nil
			p.nickemoted = false
		end
		if p.nick_wonposetrigger == nil
			p.nick_wonposetrigger = false
		end
		if p.nick_losttrigger  == nil
			p.nick_losttrigger = false
		end
		if p.tflagtwicetimer == nil
			p.tflagtwicetimer = 0
		end
		if p.tflagcount == nil
			p.tflagcount = 0
		end
		if p.nick_sitswitch == nil
			p.nick_sitswitch = false
		end
		if nk.IsPlayerOnGround(mo)
		and p.speed == 0
		and (p.playerstate == PST_LIVE)
			if (cmd.buttons & BT_TOSSFLAG)
				--Goofy aah double tap tossflag check
				if not p.tflagtwicetimer
					if not p.tossflaghold
						p.tflagtwicetimer = TICRATE/2
					end
					if p.tflagcount
						p.tflagcount = 0
					end
				else
					if not p.tossflaghold
						if p.tflagcount == 0
							p.tflagcount = $+1
						elseif p.tflagcount == 1
							p.tflagcount = $+1
						end
					end
				end
				
				--BRUH Emote
				if p.tflagcount == 1
				and p.nickemoted == false
					mo.state = S_NICKBRUH
					S_StartSound(mo, sfx_omagad)
					p.nickemoted = true
					p.nickemote_spamprotect = 1*TICRATE
					p.tflagcount = 0
				end
				
				p.tossflaghold = true
				
				--Pose 2
				if p.tossflaghold
				and not p.tflagcount
				and (cmd.buttons & BT_FIRENORMAL)
				and p.nickemoted == false
					mo.state = S_NICK_STANCE01
					p.nickemoted = true
					p.nickemote_spamprotect = 1*TICRATE
				end
				--Drip
				if p.tossflaghold
				and not p.tflagcount
				and (cmd.buttons & BT_CUSTOM2)
				and p.nickemoted == false
					mo.state = S_NICK_DRIP
					if (p == consoleplayer)
						P_PlayJingleMusic(consoleplayer, "inclub", nil, true, JT_OTHER)
					end
					if not p.nkdrip
						p.nkdrip = true
					end
					p.nickemoted = true
					p.nickemote_spamprotect = 1*TICRATE
				end
				--Fino
				if p.tossflaghold
				and not p.tflagcount
				and (cmd.buttons & BT_CUSTOM3)
				and not p.nickemoted
				and mo.state != S_NICK_FINO
					mo.state = S_NICK_FINO
					if asustado_requirement(p)
						mo.sprite2 = SPR2_ASUS
					end
					S_StartSound(mo, sfx_nkfino)
					p.nickemoted = true
					p.nickemote_spamprotect = 1*TICRATE
				end
/*-----------------Sit-----------*/
				if p.tossflaghold
				and (cmd.buttons & BT_CUSTOM1)
				and not (p.lastbuttons & BT_CUSTOM1)
				and not p.exiting
					if not p.nick_sitswitch
						mo.state = S_NICKSIT
						p.nick_sitswitch = true
					else
						mo.state = S_PLAY_STND
						p.nick_sitswitch = false
					end
				end
				if mo.state != S_NICKSIT and p.nick_sitswitch
					p.nick_sitswitch = false
				end
			elseif p.tossflaghold
				p.tossflaghold = false
			end
/*-----------------Win (Saxa's MM)-----------*/
			if (MM and gametype == GT_SAXAMM and MM:isMM())
			if MM_N.end_camera
				local sheriff = 
				((MM_N.end_killed and MM_N.end_killed.valid
				and MM_N.end_killed.p and MM_N.end_killed.p.mm.role == MMROLE_MURDERER)
				and not (MM_N.end_killer and MM_N.end_killer.valid and MM_N.end_killer.health)
				)
				and MM_N.end_killed
				or MM_N.end_killer
				
				if (sheriff and sheriff.valid)
				and p.nick_wonposetrigger == false
				and MM_N.end_camera.swirl_stage == 2
					states[S_NICK_STANCE01].tics = 9
					sheriff.state = S_NICK_STANCE01
					p.nick_wonposetrigger = true
				end
			elseif p.nick_wonposetrigger == true
				p.nick_wonposetrigger = false
				states[S_NICK_STANCE01].tics = 5
			end
			end
		end
/*--------------Style Sonic Adventure Support--------------*/
		if p.styles_tallytimer
			if not p.SA_nick_wonposetrigger
				if not p.nickemoted
				and p.styles_tallytimer == 12*TICRATE
					mo.state = S_NICK_STANCE01
					p.nickemoted = true
					p.SA_nick_wonposetrigger = true
					p.nickemote_spamprotect = 1*TICRATE
				end
			end
			if p.styles_tallytimer == 12*TICRATE
				S_StartSound(mo, sfx_nicksl, p)
			end
			states[S_NICK_STANCE01].tics = 60
			states[S_NICK_STANCE09].tics = -1
		elseif p.SA_nick_wonposetrigger
			states[S_NICK_STANCE01].tics = 5
			states[S_NICK_STANCE09].tics = 1*TICRATE
			p.SA_nick_wonposetrigger = false
		end
/*--------------Drip bounce button--------------*/
		if mo.state == S_NICK_DRIP
			local scalespeed = FU/17
			if (cmd.buttons & BT_CUSTOM3)
				if mo.spriteyscale >= (FU/2)
					mo.spriteyscale = ease.outcubic(scalespeed, $, FU/2)
					mo.spritexscale = ease.outcubic(scalespeed, $, (FU+FU/4))
				end
			elseif mo.spriteyscale <= FU
				mo.spriteyscale = ease.outcubic(scalespeed, $, FU)
				mo.spritexscale = ease.outcubic(scalespeed, $, FU)
			end
		end

/*---------------Emotes spam protect and button timers--------------*/	
		if p.tflagtwicetimer
			p.tflagtwicetimer = $-1
		end
		if p.nickemote_spamprotect
			p.nickemote_spamprotect = $-1
		elseif p.nickemoted
			p.nickemoted = false
		end
			
		if NickPoses(mo)
			if p.speed > 0
				mo.state = S_PLAY_WALK
			end
		end
		if mo.state != S_NICK_DRIP
		and p.nkdrip
			if (p == consoleplayer)
				P_RestoreMusic(consoleplayer)
			end
			mo.spriteyscale = FU
			mo.spritexscale = FU
			p.nkdrip = false
		end
		if NickPunchDamage(mo)
		and (cmd.buttons & BT_SPIN)
		and not p.canceltimer
			mo.state = S_PLAY_FALL
			S_StartSound(mo, sfx_ngskid)
		end
		if nk.IsPlayerOnGround(p.mo)
		and not nk.gamemodes()
			if p.punch_used
			and not (p.cmd.buttons & BT_SPIN)
				p.punch_used = false
			end
		end	
/*---------------Saxa's Murder Mystery showdown compatibility--------------*/
		if (MM and gametype == GT_SAXAMM and MM:isMM() and MM.showdownSprites)
		and not p.mmshowdown
			MM.showdownSprites[nk.skin] = "MMSD_NICK"
			p.mmshowdown = true
		end
/*---------------Stupid bounce sectors action--------------*/
		if nk.stupidbouncesectors(mo, mo.subsector.sector)
		or (nk.IsPlayerOnGround(mo) and mo.state == S_PLAY_CLING)
			p.nick_forceused = false
			if nk.stupidbouncesectors(mo, mo.subsector.sector)
			and not nk.IsPlayerOnGround(mo)
				mo.state = S_PLAY_ROLL
				p.pflags = $|PF_JUMPED &~(PF_THOKKED|PF_SPINNING)
				p.punch_used = false
			end
		end
		
		if nk.IsPlayerOnGround(mo)
		and p.nick_forceused then
			p.nick_forceused = false
		end
		
/*---------------PVP Power Leveling--------------*/
		if not CBW_Battle --no need for battlemod
			if mo.nk_wblevel == nil
				mo.nk_wblevel = 0
			end
			if NickPunchDamage(mo)
				if (speed < nk.WB_low_speed*mo.scale)
					if mo.nk_wblevel != 1
						mo.nk_wblevel = 1
					end
				elseif (speed >= nk.WB_low_speed*mo.scale and speed < nk.WB_medium_speed*mo.scale)
					if mo.nk_wblevel != 2
						mo.nk_wblevel = 2
					end
				elseif (speed >= nk.WB_medium_speed*mo.scale and speed < nk.WB_high_speed*mo.scale)
					if mo.nk_wblevel != 3
						mo.nk_wblevel = 3
					end
				elseif (speed >= nk.WB_medium_speed*mo.scale)
					if mo.nk_wblevel != 4
						mo.nk_wblevel = 4
					end
				end
			elseif mo.nk_wblevel > 0
				mo.nk_wblevel = 0
			end
		end
			
		--Sprint
		if (cmd.buttons & BT_CUSTOM1)
		and not (p.lastbuttons & BT_CUSTOM1)
		and not NICK_RESTRICT_SPRINT
		and nk.IsPlayerOnGround(p.mo)
		and (cmd.forwardmove or cmd.sidemove)
		and not (((p.gotflag or p.gotcrystal) and not CBW_Battle) 
		or ((CBW_Battle and CBW_Battle.TagGametype()) and not (p.battletagIT or (p.pflags&PF_TAGIT))))
		and not mo.nicktumbled
			if not p.mo.nickslidetime
			if not p.mo.dash_used
				if p.charability2 == 67
				and not p.exiting
					if (cmd.forwardmove or cmd.sidemove)
						nk.SprintThrust(p, NICK_SPRINTMOVE, NICK_THRUSTCAP_SPRINT)
					end
					if (p.mo.eflags & MFE_UNDERWATER)
						P_SetObjectMomZ(p.mo, 5*FU/2)
					else
						P_SetObjectMomZ(p.mo, 5*FRACUNIT)
					end
					p.mo.eflags = $ & ~MFE_JUSTHITFLOOR --see, this is the trick
					p.mo.state = S_PLAY_GLIDE
					p.mo.nickdash = 3
					P_SpawnGhostMobj(p.mo)
					S_StartSound(p.mo, sfx_nckspr)
					p.pflags = $ |PF_THOKKED
					p.mo.dash_used = true
				end
			end
			end
		end
		if mo.state == S_PLAY_GLIDE
			p.drawangle = p.mo.angle
		end
		
		--power up the player when using wolf buster/slide at medium speeds
		if NickPunchDamage(mo) or NickSlide(mo)
			if not nk.IsPlayerOnGround(mo) and speed >= nk.WB_medium_speed*mo.scale
			or nk.IsPlayerOnGround(mo) and speed >= nk.Slide_strongspeed*mo.scale
				p.powers[pw_strong] = $|STR_NICK
				p.nk_powerup = true
			end
			if not nk.IsPlayerOnGround(mo) and speed < nk.WB_medium_speed*mo.scale
			or nk.IsPlayerOnGround(mo) and speed < nk.Slide_strongspeed*mo.scale
				p.powers[pw_strong] = $ &~STR_NICK
				p.nk_powerup = false
			end
		elseif p.nk_powerup
			p.powers[pw_strong] = $ &~STR_NICK
			p.nk_powerup = false
		end
		--Fix equinox doing weird stuff
		if p.spintapping
		or p.spintapready
			p.spintapready = false
			p.spintapping = false
		end
	end
	end
		
/* Fixing the custom states animation still
   displayed when changing characters */
	if p.mo.skin != nk.skin
	and not p.nick_changedchar
		p.mo.state = S_PLAY_STND
		if p.mo.translation
			p.mo.translation = nil
		end
		if p.nkdrip
			if (p == consoleplayer)
				P_RestoreMusic(consoleplayer)
			end
			mo.spriteyscale = FU
			mo.spritexscale = FU
			p.nkdrip = false
		end
		p.nick_changedchar = true
	end
end
addHook("PlayerThink", Main)

addHook("AbilitySpecial", CustomDoubleJump) --Hooked Double Jump
addHook("PlayerHeight", function(p)
	if p.mo and p.mo.skin == nk.skin
		if NickSlideJump(p.mo) and p.mo.height != P_GetPlayerSpinHeight(p)
			return P_GetPlayerSpinHeight(p)
		end
		--TODO: Optimize this
		if (p.mo.state == S_NICKSIT and p.nick_sitswitch) and P_GetPlayerHeight(p) != 51*p.mo.scale
			return 51*p.mo.scale
		end
		if p.mo.state == S_NICK_STANCE01 and P_GetPlayerHeight(p) != 65*p.mo.scale
			return 65*p.mo.scale
		elseif p.mo.state == S_NICK_STANCE02 and P_GetPlayerHeight(p) != 60*p.mo.scale
			return 60*p.mo.scale
		elseif p.mo.state >= S_NICK_STANCE03 and p.mo.state <= S_NICK_STANCE09 and P_GetPlayerHeight(p) != 55*p.mo.scale
			return 55*p.mo.scale
		end
	end
end)

addHook("PlayerCanEnterSpinGaps", function(p)
	if p.mo and p.mo.skin == nk.skin
		if (NickSlideJump(p.mo)	or NickSlide(p.mo) or p.mo.state == S_PLAY_ROLL)
			return true
		else
			return false
		end
	end
end)

/*---------------PVP--------------*/
local PVP_DoDamage = function(mo, mo2, sound, dmgtype, thrust, boolean_passthrough)
	local knockbackangle = R_PointToDist2(mo.x,mo.y,mo2.x,mo2.y)
	local back = ANG1*180

	--Damage to the player inflictor
	P_DamageMobj(mo2, mo, mo, 1, dmgtype or nil)
	if thrust
		P_InstaThrust(mo2, mo.angle, thrust)
	end
	--Stuff for the player source
	if not boolean_passthrough
		P_InstaThrust(mo, mo.angle+back, 10*mo.scale)
		P_SetObjectMomZ(mo, 10*mo.scale, false)
		mo.state = S_PLAY_FALL
	end
	--FX
	if sound
		S_StartSound(mo2, sound)
	end
	local xplod = P_SpawnMobjFromMobj(mo2, 0,0,0, MT_NKEXPLD)
	xplod.color = mo.color
end

local PVP_DoSplit = function(mo, mo2, sound, thrust)
	local knockbackangle = R_PointToAngle2(mo.x,mo.y,mo2.x,mo2.y)
	local back = ANG1*180

	P_InstaThrust(mo, knockbackangle+back, thrust)
	P_InstaThrust(mo2, knockbackangle, thrust)
	P_SetObjectMomZ(mo, 10*mo.scale, false)
	P_SetObjectMomZ(mo2, 10*mo2.scale, false)
	mo.state = S_PLAY_PAIN
	mo2.state = S_PLAY_PAIN
	--FX
	if sound
		S_StartSound(mo2, sound)
	end
	local xplod = P_SpawnMobjFromMobj(mo2, 0,0,0, MT_NKEXPLD)
	xplod.color = mo.color
end

local IsP1poweredthanP2 = function(mo,mo2)
	--this function priorizes wolf buster level 
	--to decide which of both nicks will hit sucessfully
	if not (mo.skin == nk.skin and mo2.skin == nk.skin) return end --Both needs to be Nick
	local speed = FixedHypot(mo.player.rmomx, mo.player.rmomy)
	local speed2 = FixedHypot(mo2.player.rmomx, mo2.player.rmomy)
	
	--Now we compare
	if NickPunchDamage(mo) and NickPunchDamage(mo2)
		if (mo.nk_wblevel > mo2.nk_wblevel) or not mo2.nk_wblevel
			return 1 --p1 does the hit
		elseif (mo.nk_wblevel < mo2.nk_wblevel) or not mo.nk_wblevel
			return 2 --p2 does the hit
		elseif (mo.nk_wblevel == mo2.nk_wblevel)
			return 3 --both has same power
		end
	--Slide Jump
	elseif mo.nickslidejump and mo2.nickslidejump
		return 3 --both has same power
	--Slide
	elseif (mo.nickslidecheck and mo2.nickslidecheck)
		if mo.player.nick_strongapplied and not mo2.player.nick_strongapplied
			return 1
		else
			return 2
		end
		if mo.player.nick_strongapplied and mo2.player.nick_strongapplied
			return 3
		end
	end
	--Sprint
	if NickDash(mo) and NickDash(mo2)
		return 3
	end
end

local pvp = function(mo, mo2)
	if nk.gamemodes() return end
    if not (mo and mo.valid and mo2 and mo2.valid) then return end
	if mo.skin != nk.skin return end
    if not (mo.player and mo2.player) return end
	if not Nick_CanHurtPlayer(mo.player, mo2.player) return end
	if P_PlayerInPain(mo2.player) return end
	
	--hitbox checks
	local moTop = mo.z + mo.height
	local mo2Top = mo2.z + mo2.height
	if not (moTop > mo2.z and mo.z < mo2Top) return end
	local players_speed = (mo.player.speed+mo2.player.speed)/2

	--Wolf Buster
	if NickPunchDamage(mo)
		if mo2.skin == nk.skin
			if NickPunchDamage(mo2)
				if IsP1poweredthanP2(mo,mo2) == 1
					PVP_DoDamage(mo,mo2,sfx_kc40, DMG_FIRE, mo.player.speed/2)
				elseif IsP1poweredthanP2(mo,mo2) == 2
					PVP_DoDamage(mo2,mo,sfx_kc40, DMG_FIRE, mo2.player.speed/2)
				elseif IsP1poweredthanP2(mo,mo2) == 3
					PVP_DoSplit(mo,mo2,sfx_cdfm64, players_speed) --both knockbacks away. same power
				end
			else
				PVP_DoDamage(mo,mo2,sfx_kc40, DMG_FIRE, mo2.player.speed/2)
			end
		else
			PVP_DoDamage(mo,mo2,sfx_kc40, DMG_FIRE, mo.player.speed/2)
		end
	--slide
	elseif NickSlide(mo)
		if mo2.skin == nk.skin
			if NickSlide(mo2)
				if not mo2.nk_wblevel
					if IsP1poweredthanP2(mo,mo2) == 3
					and mo.player.nick_strongapplied
						PVP_DoSplit(mo,mo2,sfx_cdfm64, players_speed)
					end
					
					if not mo.player.nick_strongapplied
						if mo.player.speed > mo2.player.speed
							PVP_DoDamage(mo,mo2,sfx_kc40, nil, 0, true)
							P_SetObjectMomZ(mo2, 10*mo.scale)
						else
							PVP_DoDamage(mo2,mo,sfx_kc40, nil, 0, true)
							P_SetObjectMomZ(mo, 10*mo.scale)
						end
					end
				end
			else
				PVP_DoDamage(mo,mo2,sfx_kc40, nil, 0, true)
				P_SetObjectMomZ(mo2, 10*mo.scale)
			end
		else
			PVP_DoDamage(mo,mo2,sfx_kc40, nil, 0, true)
			P_SetObjectMomZ(mo2, 10*mo.scale)
		end
	--Slide Jump
	elseif NickSlideJump(mo)
		if mo2.skin == nk.skin
			if NickSlideJump(mo2)
				PVP_DoSplit(mo,mo2,sfx_cdfm64, players_speed)
			elseif not mo2.nk_wblevel
				PVP_DoDamage(mo,mo2,sfx_kc40, nil, 5*mo.scale)
			end
		else
			PVP_DoDamage(mo,mo2,sfx_kc40, nil, 5*mo.scale)
		end
	--Sprint
	elseif mo.state == S_PLAY_GLIDE	
		if mo2.skin == nk.skin
			if mo2.state == S_PLAY_GLIDE	
				PVP_DoSplit(mo,mo2,sfx_cdfm64, players_speed)
			elseif not mo2.nk_wblevel
				PVP_DoDamage(mo,mo2,sfx_kc40, nil, 5*mo.scale)
			end
		else
			PVP_DoDamage(mo,mo2,sfx_kc40, nil, 5*mo.scale)
		end
	end
end

addHook("MobjMoveCollide", pvp, MT_PLAYER)
addHook("MobjCollide", pvp, MT_PLAYER)

/*------------------------------Wall bump handling---------------------------*/
local wall_bumping = function(mo)
	if (mo and mo.valid and mo.player.mo and mo.player.mo.valid and mo.player and mo.skin == nk.skin)
	and mo.player.playerstate == PST_LIVE
	and not mo.player.exiting
	and not P_PlayerInPain(mo.player)
	and (NickPunchDamage(mo) or (NickDamage2(mo) and not mo.nick_homingcheck))
		if not P_IsObjectOnGround(mo)
			if nk.gamemodes() return end
			local nick_2d = (mo.flags2 & MF2_TWOD or twodlevel)
			mo.player.lastlinehit = -1
			mo.player.lastsidehit = -1
			P_SlideMove(mo)
			mo.player.powers[pw_pushing] = 3
			if nick_2d
				mo.momy = 0
			end
			local line = lines[mo.player.lastlinehit]
			if line and line.valid
				if (line.frontsector)
					if (line.frontsector.ceilingheight == line.frontsector.floorheight) and (mo.z > line.frontsector.ceilingheight)
						return
					end
				end
				if (line.backsector)
					if (line.backsector.ceilingheight == line.backsector.floorheight) and (mo.z > line.backsector.ceilingheight)
						return
					end
				end
				if not P_IsObjectOnGround(mo)
				and not P_PlayerInPain(mo.player)
				and not (line and line.backsector
				and line.backsector.ceilingpic == "F_SKY1"
				and line.frontsector
				and line.frontsector.ceilingpic == "F_SKY1"
				and (mo.z >= line.frontsector.ceilingheight
				or mo.z >= line.backsector.ceilingheight))
					local p = mo.player
					local target = mo
					local speed = FixedHypot(mo.player.rmomx, mo.player.rmomy)
				
					if NickPunchDamage(mo)
						if (consoleplayer == p)
						and speed < nk.WB_low_speed*mo.scale
							P_StartQuake(14*mo.scale, TICRATE/5, {mo.x, mo.y, mo.z})
						end
						for i = 0, 8
							local thok_dust = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
							P_Thrust(thok_dust, p.drawangle + ANGLE_90, sin(i*ANGLE_45)*10)
							P_SetObjectMomZ(thok_dust, cos(i*ANGLE_45)*10)
							if mo.nickboostmobj and mo.nickboostmobj.valid
								thok_dust.color = mo.nickboostmobj.color
							end
							thok_dust.colorized = true
							thok_dust.blendmode = AST_ADD
							thok_dust.state = S_SPINFIRE1
							thok_dust.scale = mo.scale
							thok_dust.tics = 10
							thok_dust.destscale = mo.scale/8
							thok_dust.fuse = TICRATE/2
							thok_dust.flags = $|MF_SCENERY
						end
					else
						P_StartQuake(5*mo.scale, TICRATE/5, {mo.x, mo.y, mo.z})
					end
					
					if (mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(mo, mo.player.drawangle+ANGLE_180, 5*mo.scale/2)
					else
						P_InstaThrust(mo, mo.player.drawangle+ANGLE_180, 5*mo.scale)
					end
					if NickPunchDamage(mo)
						mo.player.pflags = $ &~ PF_JUMPED
						P_DoJump(mo.player,false)
						if speed >= nk.WB_low_speed*mo.scale and speed < nk.WB_high_speed*mo.scale
							P_SetObjectMomZ(mo, mo.player.speed/11, true) --extra height on high speeds
							if (consoleplayer == p)
								P_StartQuake(25*mo.scale, TICRATE/5, {mo.x, mo.y, mo.z})
							end
						elseif speed >= nk.WB_high_speed*mo.scale
							P_SetObjectMomZ(mo, mo.player.speed/6, true) --extra height on high speeds
							if (consoleplayer == p)
								P_StartQuake(40*mo.scale, TICRATE/5, {mo.x, mo.y, mo.z})
							end
						end
						mo.player.pflags = $ &~ PF_STARTJUMP
						if not mo.player.nick_bouncedid
							mo.player.nick_bouncedid = true
						end
					else
						P_SetObjectMomZ(mo, 5*FU, false)
					end
					if NickPunchDamage(mo)
						S_StartSound(mo, sfx_s3k5f)
					else
						S_StartSound(mo, sfx_s3k49)
					end
					mo.state = S_PLAY_SPRING
					p.kickdid = false
				end
			elseif mo.player.nick_bouncedid
				mo.player.nick_bouncedid = false
			end
		end
		return true
	end
end

addHook("MobjMoveBlocked", wall_bumping, MT_PLAYER)

/*---------------------SPIN BUTTON ABILITIES----------------------*/
--
local WolfBuster = function(p)
	if p.mo and p.mo.skin == nk.skin
	and not nk.gamemodes()
	and not CBW_Battle --New Wolf Buster behavior in BattleMod.lua
		local cmd = p.cmd
		if not nk.IsPlayerOnGround(p.mo)
		--Wolf Buster
			if (p.pflags & PF_JUMPED)
				if (p.lastbuttons & BT_SPIN) return end
				if p.mo.boat return end
				if not p.punch_used
				and not p.nick_lockuncurl
				and not p.sprung
				and not p.gotflag
				and not NICK_RESTRICT_WOLFBUSTER
					p.mo.state = S_PLAY_CLING
					p.mo.momz = 0
					nk.Thrust(p, NICK_WOLFBUSTERMOVE, NICK_THRUSTCAP)
					S_StartSound(p.mo, sfx_spratk)
					p.pflags = $ |PF_JUMPED|PF_THOKKED
					p.punch_used = true
					p.kickdid = true
					p.dash_used = true
					p.cannot_nickusekick = true
					p.canceltimer = 1
				else return end
			end
		end
	end
end
addHook("SpinSpecial", WolfBuster)